//#pragma check_stack(off)
//#pragma comment(linker,"/OPT:NOWIN98")

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>

// alias to define an External DLL Command
#define mIRC(x) int __stdcall WINAPI x(HWND mWnd,HWND aWnd,char *data,char*,BOOL,BOOL)
// alias to define a WNDPROC function
#define Proc(x) LRESULT CALLBACK x(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
#define ret(x) { lstrcpy(data,x); lstrcat(data,"\0"); return 3; }

#define REBAR_TIMER 500


// ##################################################################################################

// Global Vars
HANDLE hFileMap;
LPSTR mData;
// signal variable
char signal[900];
// mIRC components HWND
HWND mIRC_hwnd, swb_hwnd, toolb_hwnd, MDI_hwnd;
// rebar HWND
HWND rebar_hwnd;
// docking dialog HWND
HWND dock_l, dock_r, dock_b, dock_t;
// docking dialog original parent HWND
HWND dockp_l, dockp_r, dockp_b ,dockp_t;
// old Window Proc
WNDPROC mIRC_OldProc, rebar_OldProc;
// switchbar position
int swb_pos;
// hide/show var
BOOL toolb_hide, swb_hide;
// indicate if MDI is maxed out
BOOL MDIismax;

UINT Tool_ID;


// ##################################################################################################

// default Load DLL structure
typedef struct {
    DWORD  mVersion;
    HWND   mHwnd;
    BOOL   mKeep;
} LOADINFO;

// Rebar Band Structure

int mIRC_swb_pos();
void mIRC_size();
void MDI_max(HWND hwnd);

int ValidID (UINT ID);
int ControlType(char *type);
int EmptyID();
int FindID (HWND fhwnd);
int FindBar(HWND hwnd,HWND fhwnd);
void ClearBands();
void Signal(char *data);
void mIRC_Eval(void);

// Removes window style to a window
void RemStyles(HWND hwnd,int parm,long RemStyles);
//	Adds window styles to a window
void AddStyles(HWND hwnd,int parm,long AddStyles);
// reset un docked window
void ResetWindow(HWND hwnd, int oldpos);