/*                                                             
Moschino[FlashBuzzen]2.36 connection by Dabba [Standalone] (This isn't the full version)

Standalone connection: passport/font setup, channel creating/listing/scanning, mass/auto room joiner, access lister.

Thanks to the testers of the recent versions; XcTHarZard, Jessy, PurpleCat, Spiffy, Solar, David.

Thanks to the original beta testers; Wayne, David, Steph, Anzar, MasterMind, d33j4y, Paige.

If you have any suggestions/problems/requests please visit http://moschino.org.uk

PS: There's nothing more annoying than to see someone hugely edit or tear apart your work. DO _NOT_ do it to my work.
*/

/*
alias sockwrite {
  sockwrite $1-
  echo -a 4sockwrite $1-
}
*/

on *:START: {
  echo -sa * Moschino[FlashBuzeen]2.36 (Standalone) connection by Dabba.
  echo -sa * Home of the Moschino connections - http://moschino.org.uk
  echo -sa * If anyone catches any problems or has suggestions please state these on the above Moschino website.

  if ($Version < 6.2) {
    echo -sace info *** This connection will only run smoothly on mIRC versions 6.2+ .. please update your mIRC.. $&
      http://www.mirc.com

    return
  }

  if (!$Isalias(Themelike_Events_Version)) {
    echo -sace info *** You need to have the Moschino[Themelike_Events].mrc loaded, this is compulsory for the connection.

    return
  }

  CheckCorrectFiles

  if ($MainSettings(AUTO_JOIN_CHANNELS_ON_START, JOIN) == 1) && ($Ini(data\GlobalSettings.ini, AUTO_JOIN, 0)) {
    hadd -m First Time Run
  }

  if ($Isfile(MOSCHINO_SETUP_README.txt)) RUN MOSCHINO_SETUP_README.txt

  if ($MainSettings(AUTO_CONNECT, CLIENT) == 1) Setup_Clientside

  if ($MainSettings(AUTO_UPDATE, PASSPORT) == 1) {
    if ($CurrentEmail) .timerUPDATE 1 2 Buzzen_Update $Ifmatch
  }

  if ($MainSettings(CONNECTION, TIMER_ACCESS) == 1) .timerACCESS 0 60 DoAccess

  Channel_Idle_Scan

  hmake qKey 50
  hmake oKey 50

  if ($Isfile(data\OwnerKeys.dat)) hload qKey data\OwnerKeys.dat
  if ($Isfile(data\HostKeys.dat)) hload oKey data\HostKeys.dat

  Connection_Version_Check
}

on *:EXIT: {
  .hsave -a qKey data\OwnerKeys.dat
  .hsave -a oKey data\HostKeys.dat

  dll -u dcx.dll
}

; Do _NOT_ remove or edit this line! The version/announcement checker uses it.
alias Con_Version return 2.36

alias CheckCorrectFiles {
  if ($Isdir($Mircdirdata)) && ($Isdir($Mircdirdlls)) && ($Isdir($MircdirIcons)) {
    Check_File_Existence Icons Forward.ico rmicon_srv.ico rmicon_user.ico Settings.ico tick.ico logo.bmp owner.ico host.ico helpop.ico info.ico user.ico
    Check_File_Existence dlls dcx.dll
    Check_GlobalSettings
  }

  else {
    echo -sace info2 * Moschino[Buzzen] can't run properly, make sure these folders are in the script directory: data, dlls, Icons, $&
      along with the necessary files in these folders.
  }
}

alias Check_File_Existence {
  var %x 1, %Files = $$2-

  while (%x <= $Numtok(%Files, 32)) {
    var %File =  $Gettok(%Files, %x, 32)
    if (!$IsFile($+($$1, /, %File))) echo -ace info2 ** Missing file ** %File in folder  $+ $$1
    inc %x
  }
}

alias Item_Exists return $Iif($Len($MainSettings($$1, $$2)) > 0, $True, $False)

alias Check_GlobalSettings {
  var %File = data/GlobalSettings.ini

  ; Default settings

  if (!$Item_Exists(CONNECTION, AUTO_CHANNEL_CREATION)) MainSettings CONNECTION AUTO_CHANNEL_CREATION 1
  if (!$Item_Exists(CONNECTION, AUTO_CREATION_CATEGORY)) MainSettings CONNECTION AUTO_CREATION_CATEGORY 4
  if (!$Item_Exists(CONNECTION, AUTO_CREATION_CATEGORY_NAME)) MainSettings CONNECTION AUTO_CREATION_CATEGORY_NAME Computing=CP
  if (!$Item_Exists(CONNECTION, USE_PASSWORD)) MainSettings CONNECTION USE_PASSWORD 1
  if (!$Item_Exists(CONNECTION, USE_TICKET)) MainSettings CONNECTION USE_TICKET 0
  if (!$Item_Exists(CONNECTION, IRC_SERVER_PORT)) MainSettings CONNECTION IRC_SERVER_PORT irc.buzzen.net:6667
  if (!$Item_Exists(CONNECTION, WEBLINK)) MainSettings CONNECTION WEBLINK www.buzzen.net
  if (!$Item_Exists(CONNECTION, LINK)) MainSettings CONNECTION LINK http://moschino.org.uk
  if (!$Item_Exists(CONNECTION, TIMER_ACCESS)) MainSettings CONNECTION TIMER_ACCESS 1
  if (!$Item_Exists(CONNECTION, IDLE_SCAN)) MainSettings CONNECTION IDLE_SCAN 1
  if (!$Item_Exists(CONNECTION, CHANNEL_IDLE_SCAN)) MainSettings CONNECTION CHANNEL_IDLE_SCAN 3
  if (!$Item_Exists(CONNECTION, ROOM_CREATION_TOPIC)) MainSettings CONNECTION ROOM_CREATION_TOPIC Moschino[FlashBuzzen] - http://moschino.org.uk
  if (!$Item_Exists(CONNECTION, ROOM_CREATION_ONJOIN)) MainSettings CONNECTION ROOM_CREATION_ONJOIN Welcome to the room rootmonkey! http://moschino.org.uk

  if (!$Item_Exists(EVENTS, AUTO_WHISPER_USERS)) MainSettings EVENTS AUTO_WHISPER_USERS 1
  if (!$Item_Exists(EVENTS, AUTO_WHISPER_MSG)) MainSettings EVENTS AUTO_WHISPER_MSG I'm AFK rootmonkies. (Automessage) catch me @ $MainSettings(CONNECTION, LINK)
  if (!$Item_Exists(EVENTS, CLOSE_WHISPER_WINDOWS)) MainSettings EVENTS CLOSE_WHISPER_WINDOWS 0
  if (!$Item_Exists(EVENTS, DISABLE_WHISPERS)) MainSettings EVENTS DISABLE_WHISPERS 0

  if (!$Item_Exists(CHANNEL_SCAN, USE_GUEST)) MainSettings CHANNEL_SCAN USE_GUEST 1
  if (!$Item_Exists(CHANNEL_SCAN, USE_PASSPORT)) MainSettings CHANNEL_SCAN USE_PASSPORT 0

  if (!$Item_Exists(FONT, FONTNAME)) MainSettings FONT FONTNAME Verdana
  if (!$Item_Exists(FONT, COLOR)) MainSettings FONT COLOR 10506797
  if (!$Item_Exists(FONT, COLOR_COMBO)) MainSettings FONT COLOR_COMBO 29
  if (!$Item_Exists(FONT,  ITALIC)) MainSettings FONT ITALIC 0
  if (!$Item_Exists(FONT, BOLD)) MainSettings FONT BOLD 0
  if (!$Item_Exists(FONT, RANDOMC)) MainSettings FONT RANDOMC 0
  if (!$Item_Exists(FONT, DONT_USE)) MainSettings FONT DONT_USE 0

  if (!$Item_Exists(AUTO_CONNECT, CLIENT)) MainSettings AUTO_CONNECT CLIENT 1

  if (!$Item_Exists(NICKLOGGER, DO_NICKLOGGING)) MainSettings NICKLOGGER DO_NICKLOGGING 1
  if (!$Item_Exists(NICKLOGGER, MSG)) MainSettings NICKLOGGER MSG 0
  if (!$Item_Exists(NICKLOGGER, ECHO)) MainSettings NICKLOGGER ECHO 1
  if (!$Item_Exists(NICKLOGGER, DO_LIMIT)) MainSettings NICKLOGGER DO_LIMIT 1
  if (!$Item_Exists(NICKLOGGER, LIMIT)) MainSettings NICKLOGGER LIMIT 15
}

alias Tag return BelisknerV.3

alias Open_Dialog $Iif(!$Dialog($1), dialog -m $1 $1)

alias RBracks return $+($Chr(40), $1-, $Chr(41)) 

alias SBracks return $+($Chr(91), $1-, $Chr(93))

alias Smarks return $+(', $1-, ')

alias Numb return $($Str($!R(0,9) $!+ $Chr(32), $$1), 2)

alias Is_Guest return $Iif($Left($$1, 1) == >, $True, $False)

alias Calc_Ticks return $Calc(($Ticks - $$1) / 1000)

alias Q OWNERKEY $Active $$1-

; For the low level, in-experienced users who don't look in remotes.
alias Pass OWNERKEY $Active $$?="What key?"

alias Setup_Clientside { 
  socklisten Local

  server LOCALHOST $Sock(Local).port
}

alias Find_Channel {
  var %Chan = $$1, %Create = $2, %Sock = $C_Sock(%Chan)

  if ($Sock(%Sock)) sockclose $Ifmatch

  tokenize 58 $MainSettings(CONNECTION, IRC_SERVER_PORT)

  sockopen %Sock $1 $2
  sockmark %Sock %Chan $Iif(%Create, CREATE)
}

alias MainSettings {
  var %File = $+(", data\GlobalSettings.ini, ")

  if ($Isid) return $Readini(%File, $1, $2-)
  else writeini %File $1-
}

alias RemSettings remini $+(", data\GlobalSettings.ini, ") $1-

alias CheckIdleChannels {
  var %x 1, %Hash = $Hget(IDLE, CHANNELS)

  while (%x <= $Numtok(%Hash, 44)) {
    var %Chan = $Gettok(%Hash, %x, 44), %Sock = $C_Sock(%Chan)

    if (!$Sock(%Sock)) || (*JOIN_SUCCESSFULL* !iswm $Sock(%Sock).mark) {
      echo -se * Attempting to rejoin %Chan as part of the idle re-connection.. $SBracks($Time)

      if ($Chan(%Chan)) sockwrite -n LOCALHOST $+(:, $Me) PART $Ifmatch

      Find_Channel %Chan
    }
    inc %x
  }

  :error
  if ($Error) reseterror
}

alias Channel_Idle_Scan {
  if ($Timer(CHECK_IDLE_CHANNELS)) .timerCHECK_IDLE_CHANNELS off

  if ($MainSettings(CONNECTION, IDLE_SCAN) == 1) {
    var %Interval = $Calc($MainSettings(CONNECTION, CHANNEL_IDLE_SCAN) * 60)

    .timerCHECK_IDLE_CHANNELS 0 %Interval CheckIdleChannels
  }
}

alias CheckNotice {
  tokenize 32 $1-

  var %C = $Mid($5, 2)

  if ($_Hex(%C) == 4D43) {
    sockwrite -n $C_Sock($3) NOTICE $3 $Right($Gettok($1, 1, 33), -1) Moschino[FlashBuzzen] $+ $Con_Version

    return $True
  }

  return $False
}

alias C_Sock return $+(CHAN., $$1)

alias _Hex {
  var %Str, %i = 1

  while ($Mid($1,%i,1) != $Null) {
    %Str = %Str $+ $Base($Asc($Ifmatch), 10, 16)
    inc %i
  }  

  return %Str
}

alias Trigger_Away_Back {
  var %x 1

  while (%x <= $Chan(0)) {
    var %Chan = $Chan(%x), %Sw = sockwrite -n $C_Sock(%Chan)

    if ($1 == GO_AWAY) {
      if ($C_Sock(%Chan)) %Sw AWAY %Chan $2-
    }
    elseif ($1 == RETURN) %Sw AWAY %Chan

    inc %x
  }
}

alias Away Trigger_Away_Back $Iif($1-, GO_AWAY $1-, RETURN)

alias Back Trigger_Away_Back RETURN

alias Hop {
  var %Chan = $Iif($1, $1, $Active)

  sockwrite -n $C_Sock(%Chan) PART %Chan $+ $CrLf $+ JOIN %Chan
}

alias Amsg {
  var %x 1 

  while (%x <= $Chan(0)) {
    msg $Chan(%x) * amsg; $1-
    inc %x
  }
}

alias RawLineFeed {
  var %Event = $$1, %Desc = $$2, %Nicks = $$3, %Prefix = %Event # %Desc, %x = 1, %Str

  while (%x <= $Numtok(%Nicks, 32)) {
    var %Nick = $Gettok(%Nicks, %x, 32)

    %Str = $Iif(%Str, %Str $+ $CrLf $+ %Prefix %Nick, %Prefix %Nick) 
    inc %x
  }

  return %str
}

alias List_Recent {
  var %x 1

  while (%x <= $Numtok(%RecentChannels, 32)) {
    var %Chan = $Gettok(%RecentChannels, %x, 32)

    if ($1 == %x) return $+(%1, .) $Chr(37) $!+ %Chan : JOIN $Chr(37) $!+ %Chan
    inc %x
  }
}

alias Write_Recent {
  var %c = $Remove($1, $Chr(37))

  if (%c !isin %RecentChannels) {
    if ($Numtok(%RecentChannels, 32) < 10) %RecentChannels = %RecentChannels %c

    else %RecentChannels = %c $Gettok(%RecentChannels, 1-9, 32)
  }
}

; Sids, slight edit.
alias que {
  if (!$Hget(que)) { 
    .hmake que 1
    hadd que 1 1
    .timerQue -m 0 $$1 queStack 
  }
  hadd que $Calc($Hget(que, 0).item + 1) $2-
}

alias queStack {
  hinc que 1

  if ($Hget(que, 1) <= $Hget(que, 0).item) $Eval($Hget(que, $Hget(que, 1)), 2)

  else { 
    .timerQue off 
    .hfree que 
  }
}

alias queStop {
  if ($Hget(que)) .hfree que 
  .timerQue off
}

alias dcx {
  if ($Isid) returnex $dll($Mircdirdlls\dcx.dll,$1,$2-)
  else dll " $+ $Mircdirdlls\dcx.dll" $1 $2-
}

alias xdid {
  if ($isid) returnex $dcx(_xdid, $1 $2 $prop $3-)
  dcx xdid $2 $3 $1 $4-
}

alias xdialog {
  if ($isid) returnex $dcx(_xdialog, $1 $prop $2-)
  dcx xdialog $2 $1 $3-
}

alias xpop {
  if ($isid) returnex $dcx( _xpop, $1 $prop $2-)
  dcx xpop $2 $1 $3-
}

alias xpopup {
  if ($isid) returnex $dcx( _xpopup, $1 $prop $2-)
  dcx xpopup $2 $1 $3-
}

alias tab {
  var %i = 1, %tab
  while (%i <= $0) {
    if ($eval($+($,%i),2) != $null) {
      %tab = $instok(%tab,$eval($+($,%i),2),$calc($numtok(%tab,9) + 1),9)
    }
    inc %i
  }
  return %tab
}

alias xdock {
  if ($isid) {
    return $dcx(_xdock, $1 $prop $2-)
  }
  else {
    dcx xdock $1-
  }
}

alias Strip_Font return $Regsubex($$1, /\[(?:style \40|/style).*?\]/gix,)

alias Get_Color_Code {
  var %A = $Asc($$1)

  if (%A == 1) return #000000
  elseif (%A == 2) return #000000
  elseif (%A == 3) return #F00000
  elseif (%A == 4) return #008000
  elseif (%A == 5) return #000080
  elseif (%A == 6) return #808000
  elseif (%A == 7) return #800080
  elseif (%A == 8) return #008080
  elseif (%A == 9) return #C0C0C0
  elseif (%A == 11) return #FF0000
  elseif (%A == 12) return #FFFFFF
  elseif (%A == 14) return #FFFF00
  elseif (%A == 15) return #FF00FF
  elseif (%A == 16) return #00FFFF

  elseif (%A == 101) return #FF0000
}

alias Get_Style_Code {
  var %A = $Asc($$1)

  if (%A == 2) return b;
  elseif (%A == 3) return i;
  elseif (%A == 4) return b;i;
}

alias Convert_MSN_Chars {
  var %StylePos = 2, %Color, %Style, %Font

  if ($Left($1-, 2) == \n) || ($Left($1-, 2) == \r) {
    %StylePos = 3

    if ($Left($1-, 2) == \n) %Color = #808080
    else %Color = #0000FF
  }
  else %Color = $Get_Color_Code($Left($1-, 1))

  %Style = $Get_Style_Code($Mid($1-, %StylePos, 1))

  %Font = $Gettok($Mid($1-, $Calc(%StylePos + 1)), 1, 59)

  tokenize 32 $Strip($1-)

  return [style $+(ff:, %Font, ;, co:, %color, ;, %Style,]) $+ $Remove($2-, $Chr(1)) $+ [/style]
}

alias Msn_To_FlashIRC {
  var %P = $1-, %Ret, %Lf = $Chr(32) $+ [br]

  %Ret = $Replace(%P,  , %Lf, , %Lf, , %Lf,  , %Lf)
  %Ret = $Replace(%Ret, , &nbsp;)
  %Ret = $Replace(%Ret, $Chr(1), &nbsp;)
  %Ret = $Replace(%Ret, \, \\)

  return %Ret
}

/*
alias Msn_To_FlashIRC2 {
  var %P = $1-, %Ret, %Lf = $Chr(32) $+ [br]

  %Ret = $Replace(%P,  , %Lf, , %Lf, , %Lf,  , %Lf)
  %Ret = $Replace(%Ret, , &nbsp;)
  %Ret = $Replace(%Ret, $Chr(194), &nbsp;)
  %Ret = $Replace(%Ret, $Chr(1), &nbsp;)
  %Ret = $Replace(%Ret, \, \\)

  return $Replace($Remove(%Ret, $Chr(160)), $Chr(2), &nbsp;)
}
*/

alias Msn_To_FlashIRC2 {
  var %P = $1-, %Ret, %Lf = $Chr(32) $+ [br]

  %Ret = $Replace(%P,  , %Lf, , %Lf, , %Lf,  , %Lf)
  ;%Ret = $Replace(%Ret, , &nbsp;)
  ;%Ret = $Replace(%Ret, $Chr(194), &nbsp;)
  %Ret = $Replace(%Ret, $Chr(1), &nbsp;)
  %Ret = $Replace(%Ret, \, \\)

  return $Replace($Remove(%Ret, $Chr(160)), $Chr(2), &nbsp;)
}

raw 800:*: halt
raw 005:*: halt
raw 352:*: halt

raw AUTH:*: halt 

on *:SOCKLISTEN:Local:{ 
  var %L = LOCALHOST

  sockaccept %L
  sockclose Local

  sockwrite -n %L $+(:, Moschino[FlashBuzzen]) 001 $Me :* mIRC's clientside %L successfully setup. You can $&
    /join $(%#aroom, ) if you have added a valid passport in the setup. $&
    Otherwise, please add a passport in the Moschino setup (right-click status screen and goto Moschino setup).

  sockmark %L CONNECTED

  if ($Hget(First, Time)) && ($MainSettings(BUZZEN_CURRENT_PASSPORT, EMAIL)) {
    Auto_Join_Channels
    hfree First
  }
}

on *:SOCKREAD:LOCALHOST:{ 
  if ($Sockerr > 0) return

  var %Local

  sockread %Local
  tokenize 32 %Local

  ;echo -a $Sockname ; %Local

  if ($1 == JOIN) {
    var %Chan = $2-

    if ($Left(%Chan, 1) != $(%, )) %Chan = $+($Chr(37), %Chan)

    ;if ($Sock($C_Sock(%Chan))) sockclose $C_Sock(%Chan)

    if (!$Chan(%Chan)) echo -ae * Attempting to join %Chan $+ , please wait, this could take a moment. $&
      If you find nothing happens, please re-attempt to join again. It's, more than likely, a problem with the server.

    if ($Sock($C_Sock(%Chan))) sockwrite -n $Ifmatch JOIN %Chan

    else {
      if ($MainSettings(BUZZEN_CURRENT_PASSPORT, EMAIL)) Find_Channel %Chan
      else echo -ae * You do not have a passport set. Please add a valid passport in the Moschino setup area.
    }
  }

  elseif ($1 == PART) {
    if ($(%#, ) isin $2) {
      hadd -m IDLE CHANNELS $Remtok($Hget(IDLE, CHANNELS), $2, 1, 44)

      sockwrite -n Localhost $+(:, $Me) PART $2
      sockclose $C_Sock($2)

      halt
    }
  }

  elseif ($1 == PRIVMSG) {
    if ($3 == :ACTION) sockwrite -n $C_Sock($2) $1-

    ; Stop other privmsg's going below.
  }

  elseif ($Sock(CHAN.*)) { 
    if ($Sock($C_Sock($2))) sockwrite -n $Ifmatch $1-

    else {
      ;sockwrite -n CHAN.* $1-

      var %x 1
      while (%x <= $Chan(0)) {
        var %Chan = $Chan(%x)

        if ($C_Sock(%Chan)) sockwrite -n $C_Sock(%Chan) $1 %Chan $2-
        inc %x
      }
    }
  }

  :error
  if ($Error) reseterror
}

on *:SOCKOPEN:CHAN.*: {
  if ($Sockerr) { 
    echo -ae * Error on socket ; $Sockname $Sockerr $Sock($Sockname).wsmsg
    return
  }

  var %Pass = $Gettok($MainSettings(BUZZEN_PASSPORTS, $CurrentEmail), 1, 32), $&
    %Sw = sockwrite -n $Sockname

  %Sw USER :BelisknerV.3

  if ($MainSettings(CONNECTION, USE_TICKET) == 1) && ($MainSettings($CurrentEmail, TICKET)) {
    %Sw UTICKET $MainSettings($CurrentEmail, TICKET)
  }

  else %Sw LOGINH $CurrentEmail $Md5(%Pass)
}

on *:SOCKREAD:CHAN.*:{
  if ($Sockerr > 0) return

  var %Chan, %Sw = sockwrite -n $Sockname, %Sm = $Sock($Sockname).mark

  sockread %Chan

  %Chan = $Strip_Font(%Chan)

  tokenize 32 %Chan

  ;echo -a $Sockname ; %Chan

  if ($Regex($5-, login successful|hostname|IRCwx 1.x auth type set)) halt

  elseif ($2 == 001) {
    if (!$Chan(0)) || ($Me != $3) sockwrite -n LOCALHOST $+(:, $Me) $+ !@buzzen.com NICK $3

    if ($Gettok(%Sm, 2, 32) == CREATE) %Sw CREATE $Gettok(%Sm, 1, 32)
    else %Sw JOIN $Gettok(%Sm, 1, 32)

    halt
  }

  elseif ($2 == 329) {
    if ($Chan($4)) echo -ct join $4 * This channel $RBracks($4) was created on $Asctime($5) | /splay conestablished.wav

    halt
  }

  elseif ($2 == 403) {
    if ($MainSettings(CONNECTION, AUTO_CHANNEL_CREATION) == 1) && ($Left($4, 2) == $(%#, )) {
      echo -ae * No such channel $4 $+ , your auto-creation option is on. Attempting to auto create %Sm $+ ..

      var %SChan = $!Chr(37) $!+ $Mid($4, 2)

      %Sw CREATE %Sm

      que 4000 %Sw PROP %SChan UNLOCK TOPIC $+ $Crlf $+ $&
        PROP %SChan UNLOCK ONJOIN $+ $Crlf $+ $&
        PROP %SChan UNLOCK CATEGORY $+ $Crlf $+ $&
        PROP %SChan UNLOCK LANGUAGE $+ $Crlf $+ $&
        PROP %SChan CATEGORY $!Gettok($MainSettings(CONNECTION, AUTO_CREATION_CATEGORY_NAME), 2, 61) $!+ $!Crlf $!+ $&
        PROP %SChan LANGUAGE en-gb $+ $Crlf $+ $&
        PROP %SChan TOPIC $!MainSettings(CONNECTION, ROOM_CREATION_TOPIC) $!+ $!Crlf $!+ $&
        PROP %SChan ONJOIN $!MainSettings(CONNECTION, ROOM_CREATION_ONJOIN)
    }

    else sockclose $Sockname

    halt
  }

  elseif ($2 == JOIN) {
    sockwrite -n LOCALHOST $1 $2 $4-

    var %C = $Mid($3, 2), $&
      %N = $Right($Gettok($1, 1, 33), -1), $&
      %Ial = $Gettok($1, 2, 33)

    if ($Gettok(%Sm, 2, 32) == CREATE) {
      var %Table = $+(CHANNEL., %C), %SChan = $!Chr(37) $!+ $Right(%C, -1)

      que 1000 %Sw PROP %SChan UNLOCK CATEGORY $+ $Crlf $+ $&
        PROP %SChan UNLOCK LANGUAGE $+ $Crlf $+ $&
        PROP %SChan UNLOCK LANGUAGE2 $+ $Crlf $+ $&
        PROP %SChan UNLOCK TOPIC $+ $Crlf $+ $&
        PROP %SChan UNLOCK ONJOIN $+ $Crlf $+ $&
        PROP %SChan UNLOCK OWNERKEY $+ $Crlf $+ $&
        PROP %SChan UNLOCK HOSTKEY

      if ($Hget(%Table, CATEGORY)) que 1000 %Sw PROP %SChan CATEGORY $Ifmatch
      if ($Hget(%Table, LANGUAGE)) que 1000 %Sw PROP %SChan LANGUAGE $Ifmatch
      if ($Hget(%Table, TOPIC)) que 1000 %Sw PROP %SChan TOPIC $Ifmatch
      if ($Hget(%Table, ONJOIN)) que 1000 %Sw PROP %SChan ONJOIN $Ifmatch
      if ($Hget(%Table, LIMIT)) que 1000 %Sw MODE %SChan +l $Ifmatch

      hadd -m IDLE CHANNELS $Addtok($Hget(IDLE, CHANNELS), %C, 44)
      sockmark $Sockname %C JOIN_SUCCESSFULL
    }

    elseif (%N == $Me) {
      hadd -m IDLE CHANNELS $Addtok($Hget(IDLE, CHANNELS), %C, 44)

      sockmark $Sockname $Sock($Sockname).mark JOIN_SUCCESSFULL

      sockwrite -n $Sockname WHO %C
    }
  }

  elseif ($2 == PROP) { 
    if ($4 == OWNERKEY) hadd -m qKey $3 $Mid($5, 2)
    elseif ($4 == HOSTKEY) hadd -m oKey $3 $Mid($5, 2)
  }

  elseif ($2 == KICK) { 
    if ($4 == $Me) sockwrite -n $Sockname JOIN $3
  }

  elseif ($2 == KILL) sockwrite -n LOCALHOST $1 KICK $Mid($Sockname, 6) $3-

  elseif ($2 == PRIVMSG) {
    if ($Regex($5, :TIME)) || ($Regex($4, /^(:+(VERSION|TIME|FINGER|DTE)+)|(:DCC|:PING) $/)) {

      if ($Regex($5, :TIME)) .signal -n CTCP_CHECK $Mid($Gettok($1, 1, 33), 2) $Mid($Sockname, 6) $4-
      else .signal -n CTCP_CHECK $Mid($Gettok($1, 1, 33), 2) $Mid($Sockname, 6) $3-

      halt
    }

    if ($(%#, ) !isin $3) {
      var %Prefix = echo $Color(action) -t $Mid($Sockname, 6) * On-screen whisper from $Right($Gettok($1, 1, 33), -1)

      if ($Left($4, 3) != :S) && ($Left($4, 2) != :) { %Prefix $4- }
      elseif ($Left($4, 3) == :S) { %Prefix $Remove($6-, ) }

      return
    }

    if (*ACTION* iswm $4) {
      ; Double char 1's, on some action commands

      sockwrite -n LOCALHOST $1-4 $5-
      halt
    }

    else {
      .signal -n WEB_THEME ON_TEXT $Sockname $1-

      sockwrite -n LOCALHOST $1-3 $Iif($Left($1, 3) != :%#, $Strip_Font($4-), $4-)
    }

    return
  }

  elseif ($2 == WHISPER) { 

    if ($Regex($5, /^(:+(VERSION|FINGER|TIME|DTE)+)|(:DCC|:PING) $/)) {
      var %C = %sw NOTICE $Mid($Gettok($1, 1, 33), 2)

      if ($4 == :TIME) %C :TIME $+($Time(m/dd/yyyy h:nn:ss TT), )
      elseif ($4 == :PING) %C :PING $+(Noob, )

      else halt
    }

    elseif (*NOUSERWHISPER* iswm $6) {
      echo -a * $1 is not accepting whispers.
      halt
    }

    else sockwrite -n LOCALHOST $1 PRIVMSG $4 $Strip_Font($5-)

    halt
  }

  elseif ($2 == NOTICE) {
    var %Chan = $Mid($Sockname, 6)

    if ($Left($4, 2) == $(%#, )) && ($Me ison $4) {
      sockwrite -n LOCALHOST : $+ $1-3 $Me $5- (Channel broadcast)
      halt
    }

    elseif ($Right($1, 3) == BCN) && ($3 == FlashIrcServer.1) {
      sockwrite -n LOCALHOST : $+ $1-2 %Chan $Me $4- (Server broadcast)
      halt
    }

    elseif ($Left($3, 2) == $(%#, )) && ($Me ison $3) {
      sockwrite -n LOCALHOST : $+ $1-3 $Me $4-
      halt
    }

    elseif ($CheckNotice($1-)) halt

    else halt
  }

  elseif ($2 == QUIT) { 
    sockwrite -n LOCALHOST $1 PART $Gettok(%Sm, 1, 32) $Gettok($1, 2, 33) - Quit $Iif($3-, : $+ $3-)

    return
  }

  /*
  elseif ($2 == 352) {
    if ($Left($9, 1) == G) hadd -m $+(AWAYS., $4) $8

    sockwrite -n LOCALHOST :FlashIrcServer.1 353 $Me = $Mid($Sockname, 6) : $+ $Mid($Remove($9, *), 2) $+ $8
  }
  */

  elseif ($2 == 353) sockwrite -n LOCALHOST $1-5 $Regsubex($6-, /([^:,\s]+,)/g, )

  elseif ($2 == 324) {
    var %Chan = $4, %Aways = $Hget(AWAYS. $+ %Chan, 0).item, %x 1

    if (%Aways) {
      while (%x <= %Aways) {
        var %Nick = $Hget(AWAYS. $+ %Chan, %x).item

        if (%Nick) && ($Chan(%Chan)) && ($Nick(%Chan, %Nick)) cline -l $Color(gray) %Chan $Fline(%Chan, %Nick, 1, 1)

        inc %x
      }

      hfree AWAYS. $+ %Chan
    }
  }

  elseif ($2 == NICK) {
    if ($+(*, $Me, *) iswm $1-) halt
  }

  elseif ($Regex($2, 404|472|482|905|908)) {
    var %Chan = $Mid($Sockname, 6)

    echo $Iif($Chan(%Chan), -e, -s) %Chan $4-
    halt
  }

  elseif ($2 == 433) {
    var %Chan = $Mid($Sockname, 6), %Nick = $+($4, $Numb(6))

    sockwrite -n LOCALHOST $+(:, $Me) NICK %Nick
    sockwrite -n $Sockname NICK %Nick $+ $Crlf $+ JOIN %Chan

    echo -ae 4* Changed your nickname to %Nick
  }

  elseif ($Regex($2, 801|802|820)) { 
    if ($2 == 801) echo -e $4 * Added $5-
    if ($2 == 802) echo -e $4 * Deleted $5-
    elseif ($2 == 820) echo -e $4 * Cleared $5

    halt
  }

  elseif ($Regex($2, 903)) {
    echo -e $Mid($Sockname, 6) * $4-
    halt 
  }

  elseif ($2 == DATA) {
    var %Chan = $Mid($Sockname, 6)

    if ($4 == PID) {
      var %N = $Mid($5, 2)

      if ($Hget(PROF_DIALOG_CHECK. $+ %Chan $+ %N, %N)) {

        Get_Profile %N $6 %Chan DIALOG_CHECK
        hfree PROF_DIALOG_CHECK. $+ %Chan $+ %N
      }

      elseif ($Hget(PROF_NORMAL_CHECK. $+ %Chan $+ %N, %N)) {

        Get_Profile %N $6 %Chan NORMAL
        hfree PROF_NORMAL_CHECK. $+ %Chan $+ %N
      }

      else Open_Profile %N $6
      halt
    }

    elseif ($5 == CMWHISP) halt
  }

  elseif ($2 == 932) {
    echo $3 * $5- $+ . Users will not see the message you just typed.
  }

  elseif ($2 == PING) {
    %Sw PONG

    halt
  }

  elseif ($Istok(913 473 471, $2, 32)) { 
    echo -a * $1-

    ;halt
  }

  elseif ($2 isin 001 002 003 004 251 252 253 254 255 265 266 301 315 366 401 403 405 422 439 441 442 451 462 482 306 914 374) return

  sockwrite -n LOCALHOST $1-

  :error
  if ($Error) reseterror
}

on *:SOCKCLOSE:CHAN.*: {
  var %S = $Sockname, %Chan = $Mid($Sockname, 6), %IP = $Sock($C_Sock(%Chan)).ip

  echo -s * Socket: %S has closed.

  sockclose %S

  if ($Chan(%Chan)) {
    Find_Channel %Chan
  }

  :error
  if ($Error) reseterror
}

menu * {
  . $chr(157) Moschino Connection  $chr(157) 𺰘
  ..Moschino setup: Open_Dialog Moschino
  .-
  ..Disconnect: sockclose *
  .-
  ..Setup your mIRC clientside connection $Iif($Sock(LOCALHOST).mark == CONNECTED, [CONNECTED], [NOT CONNECTED]) : {

    if ($Sock(LOCALHOST) && $Sock(LOCALHOST).mark == CONNECTED) {
      echo -ae * Your mIRC clientside connection has already been successfully setup.
    }

    else Setup_ClientSide

  }
  ...$Iif($MainSettings(AUTO_CONNECT, CLIENT) == 1 , $Style(1)) Always setup mIRC clientside on start : {
    MainSettings AUTO_CONNECT CLIENT $Iif($MainSettings(AUTO_CONNECT, CLIENT) == 1, 0, 1)

    echo -ae * Auto setup mIRC clientside connection on start: $Replace($MainSettings(AUTO_CONNECT, CLIENT), 1, ON, 0, OFF)
  } 
  ..-
  ..Join recent channels $+($Chr(91), $Numtok(%RecentChannels, 32), $Chr(93))
  ...$Submenu($List_Recent($1))
  .Join a channel: {
    if (!$Sock(Localhost)) Setup_ClientSide

    JOIN $$?="What channel? (IRC Format: $(%#my\broom, 0)) for Buzzen rooms) $+ $$Str($Crlf, 2) $+ Remember, case applies for flashirc channels! "
  }
  ..Join a channel via webchat (within mIRC): Webchat_Join
  ..-
  ..Create a channel: Open_Dialog Channel_creation
  .-
  ..View Flash Buzzen channel list: Open_Dialog ChatLister
  -
}


menu nicklist {
  -
   $chr(157) $+ $Buzz.decode($1) [User info] $chr(157) 𺰘
  . $+ $Buzz.decode($1) $+ : { 
    echo -ae * Nick: $1
    clipboard $1
  }
  . $+ $Iif($Ial($1).addr, $Ifmatch) $+ : echo -ae * Address: $Ial($1)
  -
   $chr(157) Select nick(s) kicks/modes $chr(157) 𺰘
  .Kick: sockwrite -n $C_Sock(#) $RawLineFeed(KICK, $Chr(32), $1-)
  .Kick + Ban: {
    var %x 1, %Nicks = $1-

    while (%x <= $Numtok(%Nicks, 32)) {
      var %Nick = $Gettok(%Nicks, %x, 32), %Ial = $Ial(%Nick).addr

      sockwrite -n $C_Sock(#) ACCESS # CLEAR HOST $+ $Crlf $+ ACCESS # ADD DENY %Ial 0 : $+ %Nick banned by $Me
      inc %x
    }
    sockwrite -n $C_Sock(#) $RawLineFeed(KICK, $Chr(32), $1-)
  }
  .-
  ..$Iif($Nick(#, $Me, '.), $Style(0), $Style(2)) +q: sockwrite -n $C_Sock(#) $RawLineFeed(MODE, +q, $1-)
  ..$Iif($Nick(#, $Me, '.), $Style(0), $Style(2)) -q: sockwrite -n $C_Sock(#) $RawLineFeed(MODE, -q, $1-)
  ..-
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) +o: sockwrite -n $C_sock(#) $RawLineFeed(MODE, +o, $1-)
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) -o: sockwrite -n $C_sock(#) $RawLineFeed(MODE, -o, $1-)
  ..-
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) +h: sockwrite -n $C_sock(#) $RawLineFeed(MODE, +h, $1-)
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) -h: sockwrite -n $C_sock(#) $RawLineFeed(MODE, -h, $1-)
  ..-
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) +v: sockwrite -n $C_sock(#) $RawLineFeed(MODE, +v, $1-)
  ...$Iif($Nick(#, $Me, '.@), $Style(0), $Style(2)) -v: sockwrite -n $C_sock(#) $RawLineFeed(MODE, -v, $1-)
  -
   $chr(157) Access $chr(157) 𺰘
  .Add owner: {
    if (!$Ial($$1).addr) {
      echo -ae * Ial for $$1 isn't stored, try again.
      WHOIS $$1
      return
    }

    ACCESS # ADD OWNER $+(*!*, $Ial($$1).addr) 0 :Added by $Me
  }
  .Add host: {
    if (!$Ial($$1).addr) {
      echo -ae * Ial for $$1 isn't stored, try again.
      WHOIS $$1
      return
    }

    ACCESS # ADD HOST $+(*!*, $Ial($$1).addr) 0 :Added by $Me
  }
  -
   $chr(157) Profile $chr(157) 𺰘
  .View users buzzen profile on web: sockwrite -n $C_Sock(#) PID $$1
  -
   $chr(157) Nicklog $chr(157) 𺰘
  .Multi-select nicklog(s) check: Nick_Check MULTI $1-
  -
}

; -- Webchat joiner.

alias Webchat_Join {
  var %Channel = $$?="What channel would you like to join via webchat? $+ $Str($Crlf, 2) $+ Do NOT specify IRC format roomnames, just give the normal $&
    roomname. $+ $Str($Crlf, 2) $+ E.g: !!!!!!!!!!!!root monkies galore!!!!!!!!!!!!!!" 

  if (%Channel) {
    Web_Join $Chan_Encode(%Channel) %Channel
  }
}

alias Chan_Encode {
  var %C = $$1

  %C = $Replace(%C, $Chr(32), \b)
  %C = $Replace(%C, \, $(%5c, ), ; , $(%3b, ))

  return $(%25%23, ) $+ %C
}

alias Web_Join {
  var %Encoded = $$1, %Decoded = $$2

  hadd -m %Decoded CHANNEL %Encoded

  if ($Window(@WEBCHAT. $+ %Decoded)) window -c @WEBCHAT. $+ %Decoded

  window @WEBCHAT. $+ %Decoded

  dialog -m Webchat. $+ %Decoded Webchat
}

dialog Webchat {
  title "Webchat"
  size -1 -1 600 480
}

alias Webchat_Callback return

on *:DIALOG:Webchat.*:INIT:0:{
  var %D = $Dname, %Channel = $Hget($Gettok(%D, 2, 46), CHANNEL)

  dcx Mark %D Webchat_Callback

  xdialog -b %D +

  xdialog -c %D 100 webctrl 0 0 640 480
  xdid -n %D 100 $+($MainSettings(CONNECTION, WEBLINK), /chatui.aspx?rm=, %Channel)

  xdialog -l %D root $Chr(9) +pv 0 0 0 0
  xdialog -l %D cell root $Chr(9) +li 100 10 0 0

  .timer 1 0 xdialog -l %D update
  .timer 1 0 xdock -c $Dialog(%D).hwnd +s $Window(@WEBCHAT. $+ $Gettok(%D, 2, 46)).hwnd
}


; -- Main dialog

dialog Moschino {
  title Moschino[FlashBuzzen]2.36 connection - $SBracks($MainSettings(CONNECTION, LINK))
  size -1 -1 271 209
  option dbu
}

on *:DIALOG:Moschino:INIT:0:{
  var %D = $Dname

  dcx Mark %D Moschino_Setup_Callback

  ; Border.
  xdialog -b %D +woty

  ; Animate.
  xdialog -a %D +ac 600

  ; /xdialog -c [DNAME] [ID] [TYPE] [X] [Y] [W] [H] (OPTIONS)

  ; Web control for the flash banner.
  xdialog -c %D 1 image 0 -37 550 150
  xdid -i %D 1 + $MircdirIcons/logo.bmp

  ; Rebar control. Add icons to tab image list. Set fonts.
  xdialog -c %D 2 rebar 0 114 150 286 varheight fixedorder vertical noresize tooltips notheme
  xdid -f %D 2 +au ansi 9 Verdana

  ; /xdid -a [DNAME] [ID] [N] [+FLAGS] [CX] [CY] [WIDTH] [ICON] [COLOR] (TEXT) [TAB] [CID] [CONTROL] [X] [Y] [W] [H] (OPTIONS) [TAB] (TOOLTIP)
  ; Create tabs, set fonts.
  xdid -a %D 2 0 +cge 0 150 220 0 $Rgb(0, 0, 255) Setup $Chr(9) 3 toolbar 0 0 400 25 vertical list flat
  xdid -a %D 2 0 +cge 0 150 0 0 $Rgb(0, 0, 255) Tools $Chr(9) 4 toolbar 0 0 400 25 vertical list flat
  xdid -a %D 2 0 +cge 0 150 0 0 $Rgb(0, 0, 255) Notifications $Chr(9) 5 toolbar 0 0 400 25 vertical list flat
  xdid -f %D 3,4,5 +a ansi 8 Verdana

  xdid -l %D 3,4,5 16
  xdid -w %D 3,4,5 +hn 0 Icons/Forward.ico

  xdid -a %D 3 0 +w 0 1 0 Passports (emails)
  xdid -a %D 3 0 +w 0 1 0 Font setup
  xdid -a %D 3 0 +w 0 1 0 Extra options

  xdid -a %D 4 0 +w 0 1 0 Mass channel joining
  xdid -a %D 4 0 +w 0 1 0 Channel scanner
  xdid -a %D 4 0 +w 0 1 0 Nicklog $Rbracks($Lines(data/Nicklog.txt) logs)

  xdid -a %D 5 0 +w 0 1 0 Announcements
  xdid -a %D 5 0 +w 0 1 0 Update system

  ; Passports panel.
  xdialog -c %D 10 panel 155 112 390 288
  xdid -x %D 10 +s
  Passports_Panel %D

  ; Fonts panel.
  xdialog -c %D 11 panel 155 112 390 288
  xdid -x %D 11 +s
  Fonts_Panel %D

  ; Connections option panel
  xdialog -c %D 795 panel 155 112 390 288
  xdid -x %D 795 +s
  Connection_Options_Panel %D

  ; Massjoin panel.
  xdialog -c %D 386 panel 155 112 390 288
  xdid -x %D 386 +s
  Massjoin_Panel %D

  ; Channel scanner panel.
  xdialog -c %D 528 panel 155 112 390 288
  xdid -x %D 528 +s
  ChannelScanner_Panel %D

  ; Nicklogger panel.
  xdialog -c %D 837 panel 155 112 390 288
  xdid -x %D 837 +s
  Nicklogger_Panel %D

  ; Add all panels to xdialog +z
  xdialog -z %D +a 10
  xdialog -z %D +a 11
  xdialog -z %D +a 795
  xdialog -z %D +a 386
  xdialog -z %D +a 528
  xdialog -z %D +a 837

  ; Statusbar.
  xdialog -c %D 6 statusbar 140 30 100 20 grip tooltips
  xdid -l %D 6 155 355 -1
  xdid -f %D 6 +a ansi 8 Verdana
  xdid -v %D 6 1 Connection version: $Con_Version
  xdid -v %D 6 2 Update available: $Iif($Hget(CONNECTION, UPDATE) == NEEDED, Yes!, No)
  xdid -v %D 6 3 Announcements logged: $Ini(data/GlobalSettings.ini, ANNOUNCEMENTS, 0)

  xdialog -z %D +s 1
}

; -- Main dialog callback alias

alias Moschino_Setup_Callback {
  var %D = Moschino

  ;echo -a $1-

  if ($2 == SCLICK) {

    ;echo -a $1-

    ; Rebar toolbar clicks
    if ($3 == 3) && ($4) {

      xdialog -z %D +s $4

      ; Clicking on fonts bar.
      if ($4 == 2) {

        var %Section = FONTS_ $+ $Win_Key

        if (!$Isfile(data\Fonts.dat)) || (!$Ini(data\Fonts.dat, %Section, 0)) || ($Ini(data\Fonts.dat, %Section, 0) == 0) {
          if ($Dialog(Moschino)) dialog -x Moschino

          echo -ae * Loading your system fonts, this may take a while. Please be patient..
          Store_Fonts
        }
      }
    }

    elseif ($3 == 4) && ($4) xdialog -z %D +s $Calc($4 + 3)

    elseif ($3 == 5) && ($4) {
      $Input(This panel in under construction and will be made available on the next version! $Str($Crlf, 2) $+ $&
        If you have any further suggestions/problems please visit $MainSettings(CONNECTION, LINK),o , Moschino[FlashBuzzen])
    }

    ; Passport panel sclicks
    elseif ($3 == 14) $Email_Settings().ADD
    elseif ($3 == 656) MainSettings AUTO_UPDATE PASSPORT $xdid(%D, 656).state

    ; Font preview clicks.
    elseif ($3 == 15) {
      hadd -m FONT FONTNAME $xdid(%D, 15, 0).seltext
      Show_Font_Selection
    }
    elseif ($3 == 16) {
      hadd -m FONT COLOR $xdid(%D, 16, $4).color
      hadd -m FONT COLOR_COMBO $4

      Show_Font_Selection
    }
    elseif ($3 == 22) {
      var %State = $xdid(%D, 22).state

      if (%State == 1)  xdid -b %D 16 
      elseif (%State == 0) xdid -e %D 16 
      hadd -m FONT RANDOM_COLOR %State

      Show_Font_Selection
    }
    elseif ($3 == 23) {
      hadd -m FONT ITALIC $xdid(%D, 23).state
      Show_Font_Selection
    }
    elseif ($3 == 24) {
      hadd -m FONT BOLD $xdid(%D, 24).state
      Show_Font_Selection
    }

    elseif ($3 == 78) {
      var %State = $xdid(%D, 78).state

      if (%State == 0) {
        xdid -e %D 15
        xdid -e %D 16
        xdid -e %D 22
        xdid -e %D 23
        xdid -e %D 24
        xdid -e %D 738
        MainSettings FONT DONT_USE 0
      }
      else {
        xdid -b %D 15
        xdid -b %D 16
        xdid -b %D 22
        xdid -b %D 23
        xdid -b %D 24
        xdid -b %D 738
        MainSettings FONT DONT_USE 1
      }
    }

    elseif ($3 == 847) {
      var %Font = $Hget(FONT, FONTNAME), %Color = $Hget(FONT, COLOR), $&
        %Italic = $Hget(FONT, ITALIC), %Bold = $Hget(FONT, BOLD), %RandomC = $Hget(FONT, RANDOM_COLOR), $&
        %Color_Combo = $Hget(FONT, COLOR_COMBO)

      if (%Font != $Null) MainSettings FONT FONTNAME %Font
      if (%Color != $Null) MainSettings FONT COLOR %Color
      if (%Italic != $Null) MainSettings FONT ITALIC %Italic
      if (%Bold != $Null) MainSettings FONT BOLD %Bold
      if (%RandomC != $Null) MainSettings FONT RANDOMC %RandomC
      if (%Color_Combo != $Null) MainSettings FONT COLOR_COMBO %Color_Combo

      echo -ae * Saved your new font details.
      dialog -x %D
    }

    elseif ($3 == 848) {
      if ($Isfile(data\Fonts.dat)) .remove data\Fonts.dat

      if ($Dialog(Moschino)) dialog -x Moschino

      echo -ae * Refreshing your system fonts, this may take a while. Please be patient..
      Store_Fonts
    }

    ; Connection options panel sclicks
    elseif ($3 == 4948) {
      var %State = $xdid(%D, 4948).state

      if (%State == 1) { 
        MainSettings CONNECTION USE_PASSWORD 1
        MainSettings CONNECTION USE_TICKET 0
        xdid -u %D 4949
      }
      elseif (%State == 0) {
        MainSettings CONNECTION USE_PASSWORD 0
        MainSettings CONNECTION USE_TICKET 1
        xdid -c %D 4949
      }
    }
    elseif ($3 == 4949) {
      var %State = $xdid(%D, 4949).state

      if (%State == 1) { 
        MainSettings CONNECTION USE_PASSWORD 0
        MainSettings CONNECTION USE_TICKET 1
        xdid -u %D 4948
      }
      elseif (%State == 0) {
        MainSettings CONNECTION USE_PASSWORD 1
        MainSettings CONNECTION USE_TICKET 0
        xdid -c %D 4948
      }
    }

    ; Whisper events.
    elseif ($3 == 312) {
      var %State = $xdid(%D, 312).state

      if (%State == 1) { 
        MainSettings EVENTS AUTO_WHISPER_USERS 1
        xdid -e %D 313
      }
      elseif (%State == 0) {
        MainSettings EVENTS AUTO_WHISPER_USERS 0
        xdid -b %D 313
      }
    }

    elseif ($3 == 314) MainSettings EVENTS CLOSE_WHISPER_WINDOWS $xdid(%D, 314).state
    elseif ($3 == 315) MainSettings EVENTS DISABLE_WHISPERS $xdid(%D, 315).state

    elseif ($3 == 411) {
      var %State = $xdid(%D, 411).state

      if (%State == 1) { 
        MainSettings CONNECTION AUTO_CHANNEL_CREATION 1
        xdid -e %D 412,6438,7845
      }
      elseif (%State == 0) {
        MainSettings CONNECTION AUTO_CHANNEL_CREATION 0
        xdid -b %D 412,6438,7845
      }
    }

    elseif ($3 == 412) {
      MainSettings CONNECTION AUTO_CREATION_CATEGORY $4
      MainSettings CONNECTION AUTO_CREATION_CATEGORY_NAME $xdid(%D, 412).seltext
    }

    elseif ($3 == 903) MainSettings AUTO_JOIN_CHANNELS_ON_START JOIN $xdid(%D, 903).state
    elseif ($3 == 490) {
      var %Chan = $Input(Add to favourite?, qe, Mass room join, $+($Chr(37), #blah))

      if (%Chan) var %Note = $Input(Note?, qe, Mass room join, cool chan!)

      if (%Note) MainSettings MASS_JOIN %Chan %Note

      List_Mass_Channels
    }
    elseif ($3 == 491) Mass_Join_Channels
    elseif ($3 == 492) dialog -x Moschino

    ; Channel scanner sclicks

    elseif ($3 == 532) {
      xdid -r $1 529
      Channel_Scan $xdid($1, 531).text
    }

    ; Nicklogger sclicks

    elseif ($3 == 5436) {
      var %State = $xdid(%D, 5436).state

      if (%State == 1) { 
        MainSettings NICKLOGGER DO_NICKLOGGING 1
        xdid -e %D 5437,5438
      }
      elseif (%State == 0) {
        MainSettings NICKLOGGER DO_NICKLOGGING 0
        xdid -b %D 5437,5438
      }
    }

    elseif ($3 == 5437) {
      var %State = $xdid(%D, 5437).state

      MainSettings NICKLOGGER MSG $Iif(%State == 1, 1, 0)
    }

    elseif ($3 == 5438) {
      var %State = $xdid(%D, 5438).state

      MainSettings NICKLOGGER ECHO $Iif(%State == 1, 1, 0)
    }

    elseif ($3 == 5439) {
      var %State = $xdid(%D, 5439).state

      if (%State == 1) { 
        MainSettings NICKLOGGER DO_LIMIT 1
        xdid -e %D 5321
      }
      elseif (%State == 0) {
        MainSettings NICKLOGGER DO_LIMIT 0
        xdid -b %D 5321
      }
    }

    elseif ($3 == 16895) Nick_Check DIALOG $xdid(%D, 4379).text
  }

  elseif ($2 == MOUSE) {
    if ($3 == 866) || ($3 == 876) {
      MainSettings CONNECTION CHANNEL_IDLE_SCAN $xdid(Moschino, 866).value

      Channel_Idle_Scan
    }

    elseif ($3 == 5321) || ($3 == 5322) MainSettings NICKLOGGER LIMIT $xdid(Moschino, 5322).value
  }

  elseif ($2 == LBDOWN) {
    if ($3 == 111) {
      var %State = $xdid($1, 111).state

      if (%State == 1) { 
        MainSettings CHANNEL_SCAN USE_GUEST 0
        MainSettings CHANNEL_SCAN USE_PASSPORT 1
        xdid -c $1 112
      }
      elseif (%State == 0) {
        MainSettings CHANNEL_SCAN USE_GUEST 1
        MainSettings CHANNEL_SCAN USE_PASSPORT 0
        xdid -u $1 112
      }
    }

    elseif ($3 == 112) {
      var %State = $xdid($1, 112).state

      if (%State == 1) { 
        MainSettings CHANNEL_SCAN USE_PASSPORT 0
        MainSettings CHANNEL_SCAN USE_GUEST 1
        xdid -c $1 111
      }
      elseif (%State == 0) {
        MainSettings CHANNEL_SCAN USE_PASSPORT 1
        MainSettings CHANNEL_SCAN USE_GUEST 0
        xdid -u $1 111
      }
    }

    elseif ($3 == 643) {
      var %State = $xdid($1, 643).state

      if (%State == 1) { 
        MainSettings CONNECTION IDLE_SCAN 0
        xdid -b $1 866
        xdid -b $1 876

        Channel_Idle_Scan
      }
      elseif (%State == 0) {
        MainSettings CONNECTION IDLE_SCAN 1
        xdid -e $1 866
        xdid -e $1 876

        Channel_Idle_Scan
      }
    }
  }

  elseif ($2 == RCLICK) {
    if ($3 == 12) && ($4-) {
      var %Menu = PASSPORTS_LISTVIEW

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) +g 1 0 Email: $xdid(%D, 12, 0).seltext
      xpop -a %Menu 0 $Chr(9) + 2 0 -
      xpop -a %Menu 0 $Chr(9) + 3 0 Update this passport
      xpop -a %Menu 0 $Chr(9) + 4 0 Edit this passport
      xpop -a %Menu 0 $Chr(9) + 5 0 Remove
      xpop -a %Menu 0 $Chr(9) + 6 0 -
      xpop -a %Menu 0 $Chr(9) $Iif($MainSettings(BUZZEN_CURRENT_PASSPORT, EMAIL) == $xdid(%D, 12, 0).seltext, +g, +) 7 0 Switch to this passport without updating

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }

    elseif ($3 == 927) && ($4-) {
      var %Menu = MASSJOIN_LISTVIEW

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) +g 1 0 Channel: $Mid($xdid(%D, 927, 0).seltext, 3)
      xpop -a %Menu 0 $Chr(9) + 2 0 -
      xpop -a %Menu 0 $Chr(9) + 3 0 Remove from list
      xpop -a %Menu 0 $Chr(9) + 4 0 Join
      xpop -a %Menu 0 $Chr(9) + 5 0 Add channel to on-start auto join
      xpop -a %Menu 0 $Chr(9) + 6 0 Remove channel from on-start auto join

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }

    elseif ($3 == 286) && ($4-) {
      var %Menu = NICKLOGGER_LISTVIEW

      if ($xpopup(%Menu).ismenu) xpopup -d %Menu

      xpopup -c %Menu verticalrev 

      xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
        $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
        $Rgb(248, 248, 255)

      xpop -a %Menu 0 $Chr(9) +g 1 0 Address: $Left($xdid(%D, 286, 0).seltext, 10) $+ ..
      xpop -a %Menu 0 $Chr(9) + 2 0 -
      xpop -a %Menu 0 $Chr(9) + 3 0 Echo entry
      xpop -a %Menu 0 $Chr(9) + 4 0 Clipboard entry

      xpopup -s %Menu + $Mouse.dx $Mouse.dy
    }
  }

  elseif ($2 == KEYUP) {
    ;echo -a $1-

    if ($3 == 313) MainSettings EVENTS AUTO_WHISPER_MSG $xdid(%D, 313).text
    elseif ($3 == 601) MainSettings CONNECTION IRC_SERVER_PORT $xdid(%D, 601).text
    elseif ($3 == 801) MainSettings CONNECTION WEBLINK $xdid(%D, 801).text

    elseif ($3 == 6438) MainSettings CONNECTION ROOM_CREATION_TOPIC $xdid(%D, 6438).text
    elseif ($3 == 7845) MainSettings CONNECTION ROOM_CREATION_TOPIC $xdid(%D, 7845).text
  }
}

; -- Main dialog xpopup signal event

on *:SIGNAL:Xpopup-*: {
  var %D = Moschino, %Menu_Name = $Gettok($Signal, 2-, 45)

  if (%Menu_Name == PASSPORTS_LISTVIEW) {
    var %Email = $xdid(%D, 12, 0).seltext

    if ($1 == 3) Buzzen_Update %Email
    elseif ($1 == 4) $Email_Settings(%Email).EDIT
    elseif ($1 == 5) $Email_Settings(%Email).REMOVE
    elseif ($1 == 7) {
      MainSettings BUZZEN_CURRENT_PASSPORT EMAIL %Email
      MainSettings BUZZEN_CURRENT_PASSPORT PASSWORD $Gettok($MainSettings(BUZZEN_PASSPORTS, %Email), 1, 32)

      Refresh_Email_Lists
    }
  }

  elseif (%Menu_Name == CHANNELS_LISTVIEW) {
    var %Channel = $xdid(ChatLister, 6, 0).seltext

    if ($1 == 3) JOIN %Channel
    elseif ($1 == 4) MainSettings MASS_JOIN %Channel Added from chanlister!
    elseif ($1 == 5) CLIPBOARD %Channel
  }

  elseif (%Menu_Name == ACCESS_LISTVIEW) {
    var %Chan = $Hget(Access, List), %Sw = sockwrite -n $C_Sock(%Chan) ACCESS %Chan, $&
      %Type = $xdid(AccessLister, 1, 0).seltext, %Mask = $xdid(AccessLister, 1, 2).seltext

    if ($1 == 3) {
      var %Selected = $xdid(AccessLister, 1).sel, %x 1

      while (%x <= $Numtok(%Selected, 44)) {
        var %ID = $Gettok(%Selected, %x, 44)

        %Sw DELETE $xdid(AccessLister, 1, %ID, 0).text $xdid(AccessLister, 1, %ID, 2).text

        inc %x
      }

      xdid -r AccessLister 1
      %Sw LIST
    }
    elseif ($1 == 4) CLIPBOARD $SBracks(%Type) $SBracks(%Mask)
    elseif ($1 == 6) {
      var %Chan = $Hget(Access, List)

      xdid -r AccessLister 1
      sockwrite -n $C_Sock(%Chan) ACCESS %Chan LIST
    }
  }

  elseif (%Menu_Name == MASSJOIN_LISTVIEW) {
    var %Chan = $xdid(Moschino, 927, 0).seltext

    if ($1 == 3) {
      var %Confirm = $Input(Are you sure you want to remove %Chan from favourites?, y, Mass room join)

      if (%Confirm) {
        RemSettings MASS_JOIN %Chan
        RemSettings AUTO_JOIN %Chan
      }

      List_Mass_Channels
    }
    elseif ($1 == 4) JOIN %Chan
    elseif ($1 == 5) { MainSettings AUTO_JOIN %Chan TRUE | List_Mass_Channels }
    elseif ($1 == 6) { RemSettings AUTO_JOIN %Chan | List_Mass_Channels }
  }

  elseif (%Menu_Name == PROFILE_LISTVIEW) {
    var %Nick = $Gettok($xdid(ProfileManager, 1, 0).seltext, 1, 32), %_Nick = $Hget(PROFILE_D, %Nick)

    if ($1 == 3) {
      hadd -m PROF_DIALOG_CHECK. $+ $Active $+ %_Nick %_Nick %_Nick
      sockwrite -n $C_Sock($Active) PID %_Nick

      xdid -r ProfileManager 2
    }
  }

  elseif (%Menu_Name == NICKLOGGER_LISTVIEW) {
    var %Data =  $xdid(Moschino, 286, 0).seltext - $xdid(Moschino, 286, 1).seltext

    if ($1 == 3) echo -ae * %Data
    elseif ($1 == 4) CLIPBOARD %Data
  }
}

; -- Passport panel and events

alias Passports_Panel {
  var %D = $$1

  ; Listview control.
  xdid -c %D 10 12 listview 4 2 381 182 report grid borderselect flatsb fullrow
  xdid -t %D 12 +l 0 180 Username (right-click usernames) $Chr(9) +l 0 250 Passport note

  ; Icons.
  xdid -w %D 12 +n 0 Icons/tick.ico
  xdid -w %D 12 +n 1 Icons/rmicon_user.ico

  ; Box control.
  xdid -c %D 10 13 box 4 190 381 63
  xdid -t %D 13 Passport details

  ; Text controls.
  xdid -c %D 10 6847 text 12 210 320 20
  xdid -c %D 10 3826 text 12 230 320 20

  ; Check box
  xdid -c %D 10 656 check 4 259 170 25
  xdid -t %D 656 Auto update passport on start

  ; Buttons.
  xdid -c %D 10 14 button 284 257 100 25
  xdid -l %D 14 16
  xdid -w %D 14 +n 0 Icons/Settings.ico
  xdid -t %D 14 Add New email

  ; Font.
  xdid -f %D 12,13,656,14,6847,3826 +a ansi 8 Tahoma

  List_Passport_Stats
}

alias List_Passport_Stats {
  if ($Dialog(Moschino)) {
    var %File = Data\GlobalSettings.ini, %x 1, %IniSection = BUZZEN_PASSPORTS

    while (%x <= $Ini(%File, %IniSection, 0)) {
      var %Email = $Ini(%File, %IniSection, %x)

      var %Note = $Gettok($MainSettings(%IniSection, %Email), 2-, 32)

      xdid -a Moschino 12 0 0 $Iif(%Email == $CurrentEmail, +b 1, + 0) 2 0 0 0 0 %Email $Chr(9) -2 0 0 0 %Note 

      inc %x
    }

    if ($MainSettings(AUTO_UPDATE, PASSPORT) == 1) xdid -c Moschino 656

    xdid -t Moschino 6847 Ticket: $Iif($MainSettings($CurrentEmail, TICKET), $Left($Ifmatch, 40) $+ .., Not set)
    xdid -t Moschino 3826 Ticket expiry: $Iif($MainSettings($CurrentEmail, EXPIRES), $Ifmatch, Not set)

    if ($MainSettings(AUTO_UPDATE, PASSPORT) == 1) xdid -c Moschino 656
    if ($MainSettings(CONNECTION, GRAB_PASSPORT_TICKET) == 1) xdid -c Moschino 736
  }
}

alias Is_Valid_Email return $Regex($1, /^.+@.+\..{2 $+ $Chr(44) $+ 6}$/g)

alias CurrentEmail return $Iif($MainSettings(BUZZEN_CURRENT_PASSPORT, EMAIL), $Ifmatch, $Null)

alias Refresh_Email_Lists {
  if ($Dialog(Moschino)) {
    xdid -r Moschino 12

    List_Passport_Stats
  }
}

alias Email_Settings { 
  if ($Prop == ADD) {
    var %Email = $Input(Enter your flash buzzen email, qe, Email, blah@msn.com), %Pass

    if (!%Email) return
    if ($MainSettings(BUZZEN_PASSPORTS, %Email)) echo -ae * You already have the email $SBracks(%Email) in your passport listings..

    else %Pass = $Input(Enter your password.., pqe, Password)

    if (!%Pass) return

    if (%Email) && (%Pass) { 
      var %Note = $Input(Enter a note for the passport.., qe, Email note, New flash Buzzen passport!)

      if (%Note) {
        MainSettings BUZZEN_PASSPORTS %Email %Pass %Note

        Refresh_Email_Lists

        Buzzen_Update %Email
      }
    }

    else echo -ae * Sorry, there seems to be a problem with your email input. Please try again.
  }

  elseif ($Prop == EDIT) {
    var %Email = $$1, %Details = $MainSettings(BUZZEN_PASSPORTS, %Email), %NewEmail, %NewPassword, %NewNote

    tokenize 32 %Details

    var %Password = $1, %Note = $2-, $&
      %EditEmail? = $Input(Edit your email if required., qe, Edit email, %Email)

    %NewEmail = $Iif(%EditEmail?, $Ifmatch, %Email)

    var %EditPassword? = $Input(Edit your password if required., qe, Edit password, %Password)
    %NewPassword = $Iif(%EditPassword?, $Ifmatch, %Password)

    var %EditNote? = $Input(Edit your email note if required., qe, Edit note, %Note)
    %NewNote = $Iif(%EditNote?, $Ifmatch, %Note)

    RemSettings BUZZEN_PASSPORTS %Email
    MainSettings BUZZEN_PASSPORTS %NewEmail %NewPassword %NewNote

    Refresh_Email_Lists
  }

  else {
    var %Rem = $input(Are you sure you would like to remove this passport from file: $+ $str($CrLf, 2) $+ $1- $+ ?, y, Passport removal)

    if (%Rem) {
      RemSettings BUZZEN_PASSPORTS $1
      remini data/GlobalSettings.ini $1

      Refresh_Email_Lists
    }
  }
}

alias Buzzen_Update { 
  var %Email = $$1, %Password = $Gettok($MainSettings(BUZZEN_PASSPORTS, %Email), 1, 32)

  var %Sock = $+(GET_TICKET., $Numb(8))

  echo -ae * Attempting to grab ticket for buzzen flash passport: $+($Chr(2), %Email, $Chr(15), $Chr(44)) please wait a moment..

  sockopen %Sock $MainSettings(CONNECTION, WEBLINK) 80
  sockmark %Sock %Email %Password $Ticks
}

alias EncodeLine return $Replace($$1, $(%40, ), @)

alias Ticket_Content return $+(__VIEWSTATE=, $$1, &flag=&sh_loginid=, $$2, &sh_pwd=, $$3, &btnSubmit=Login)

on *:SOCKOPEN:GET_TICKET.*: {
  if ($Sockerr) {
    echo -ae * Error on socket ; $Sockname $Sockerr $Sock($Sockname).wsmsg
    return 
  }

  tokenize 32 $Sock($Sockname).mark

  var %Content = $+(&flag=posted&sh_loginid=, $1, &sh_pwd=, $2, &btnSubmit=Login)

  sockwrite -n $Sockname POST /signin.aspx HTTP/1.1 $+ $Crlf $+ $&
    Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */* $+ $Crlf $+ $&
    Referer: http:// $+ $MainSettings(CONNECTION, WEBLINK) $+ /signin.aspx $+ $Crlf $+ $&
    Accept-Language: en-us $+ $Crlf $+ $&
    Content-Type: application/x-www-form-urlencoded $+ $Crlf $+ $&
    Accept-Encoding: gzip, deflate $+ $Crlf $+ $&
    User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322) $+ $Crlf $+ $&
    Host: $MainSettings(CONNECTION, WEBLINK) $+ $Crlf $+ $&
    Content-Length: $Len(%Content) $+ $Crlf $+ $&
    Connection: Keep-Alive $+ $Crlf $+ $&
    Cache-Control: no-cache $+ $Str($Crlf, 2) $+ %Content $+ $Str($Crlf, 2)
}

on *:SOCKREAD:GET_TICKET.*: {
  if ($Sockerr > 0) return

  var %Role, %SM = $Sock($Sockname).mark, %Email = $Gettok(%SM, 1, 32), %Pass = $Gettok(%SM, 2, 32)
  sockread %Role 

  ;echo -a %Role

  if ($Regex(%Role, /__VIEWSTATE" value="(.+?)\"/i)) {
    var %ViewState = $Replace($Regml(1), +, $(%2B, ), /, $(%2F, ))

    .timer $+ $Numb(10) 1 1 if ($Sock( $Sockname )) sockwrite -n $Sockname POST /signin.aspx HTTP/1.1 $+ $Crlf $+ $&
      Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */* $+ $Crlf $+ $&
      Referer: http:// $+ $MainSettings(CONNECTION, WEBLINK) $+ /signin.aspx $+ $Crlf $+ $&
      Accept-Language: en-us $+ $Crlf $+ $&
      Content-Type: application/x-www-form-urlencoded $+ $Crlf $+ $&
      Accept-Encoding: gzip, deflate $+ $Crlf $+ $&
      User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322) $+ $Crlf $+ $&
      Host: $MainSettings(CONNECTION, WEBLINK) $+ $Crlf $+ $&
      Content-Length: $Len($Ticket_Content(%ViewState, %Email, %Pass)) $+ $Crlf $+ $&
      Connection: Keep-Alive $+ $Crlf $+ $&
      Cache-Control: no-cache $+ $Str($Crlf, 2) $+ $Ticket_Content(%ViewState, %Email, %Pass) $+ $Str($Crlf, 2)
  }

  if ($Regex(%Role, /uticket=(.+?);/i)) {
    var %Capture = $EncodeLine($Regml(1))

    if ($Len(%Capture) > 10) {
      MainSettings BUZZEN_CURRENT_PASSPORT EMAIL %Email
      MainSettings BUZZEN_CURRENT_PASSPORT PASSWORD %Pass

      MainSettings %Email TICKET %Capture

      .echo -q $Regex(%Role, /expires=(.+?);/i)
      MainSettings %Email EXPIRES $Regml(1)

      echo -ae * Updated passport for email $Sbracks(%Email) in $Calc_Ticks($Gettok(%SM, 3, 32)) secs. $&
        If your mIRC localhost is setup, you can now join rooms.

      sockclose $Sockname

      if ($Dialog(Moschino)) Refresh_Email_Lists
    }
    else { 
      echo -se * Failed to grab the passport ticket for email $SBracks(%Email) $+ . $&
        If you keep getting this error when you try to update, please check your email/password again.

      sockclose $Sockname
    }
  }

  if (*The passwords you entered did not match* iswm %Role) { 
    echo -se * The email %Email doesn't seem to be a valid flash Buzzen email.

    sockclose $Sockname 
  }
}

; -- Font panel and events

alias Fonts_Panel {
  var %D = $$1

  ; Listview control.
  xdid -c %D 11 15 listview 4 4 230 160 report borderselect flatsb
  xdid -t %D 15 +l 0 220 Your system fonts $RBracks($Calc($Lines(Data\Fonts.dat) - 1))

  ; ColorCombo control.
  xdid -c %D 11 16 colorcombo 238 3 147 400
  xdid -a %D 16 0 $Rgb(0, 0, 0)
  xdid -a %D 16 0 $Rgb(0, 255, 255)
  xdid -a %D 16 0 $Rgb(50, 205, 154)
  xdid -a %D 16 0 $Rgb(0, 255, 0)
  xdid -a %D 16 0 $Rgb(152, 251, 152)
  xdid -a %D 16 0 $Rgb(0, 128, 0)
  xdid -a %D 16 0 $Rgb(0, 100, 0)
  xdid -a %D 16 0 $Rgb(47, 107, 85)
  xdid -a %D 16 0 $Rgb(0, 128, 128)
  xdid -a %D 16 0 $Rgb(238, 238, 175)
  xdid -a %D 16 0 $Rgb(230, 216, 173)
  xdid -a %D 16 0 $Rgb(255, 0, 0)
  xdid -a %D 16 0 $Rgb(255, 191, 0)
  xdid -a %D 16 0 $Rgb(225, 105, 65)
  xdid -a %D 16 0 $Rgb(128, 0, 0)
  xdid -a %D 16 0 $Rgb(139, 61, 72)
  xdid -a %D 16 0 $Rgb(221, 160, 221)
  xdid -a %D 16 0 $Rgb(204, 50, 153)
  xdid -a %D 16 0 $Rgb(128, 0, 128)
  xdid -a %D 16 0 $Rgb(130, 0, 75)
  xdid -a %D 16 0 $Rgb(79, 79, 47)
  xdid -a %D 16 0 $Rgb(0, 0, 128)
  xdid -a %D 16 0 $Rgb(0, 0, 139)
  xdid -a %D 16 0 $Rgb(0, 165, 255)
  xdid -a %D 16 0 $Rgb(0, 140, 255)
  xdid -a %D 16 0 $Rgb(204, 209, 72)
  xdid -a %D 16 0 $Rgb(128, 128, 0)
  xdid -a %D 16 0 $Rgb(0, 0, 255)
  xdid -a %D 16 0 $Rgb(45, 82, 160)
  xdid -a %D 16 0 $Rgb(96, 164, 244)
  xdid -a %D 16 0 $Rgb(87, 139, 46)
  xdid -a %D 16 0 $Rgb(105, 105, 105)
  xdid -a %D 16 0 $Rgb(128, 128, 128)
  xdid -a %D 16 0 $Rgb(144, 128, 112)
  xdid -a %D 16 0 $Rgb(192, 192, 192)
  xdid -a %D 16 0 $Rgb(203, 192, 255)
  xdid -a %D 16 0 $Rgb(255, 0, 255)
  xdid -a %D 16 0 $Rgb(180, 105, 255)
  xdid -a %D 16 0 $Rgb(255, 255, 0)
  xdid -a %D 16 0 $Rgb(205, 250, 255)
  xdid -a %D 16 0 $Rgb(179, 222, 245)
  xdid -a %D 16 0 $Rgb(0, 215, 255)
  xdid -a %D 16 0 $Rgb(32, 165, 218)
  xdid -a %D 16 0 $Rgb(11, 134, 184)
  xdid -a %D 16 0 $Rgb(140, 230, 240)
  xdid -a %D 16 0 $Rgb(107, 183, 189)
  xdid -a %D 16 0 $Rgb(255, 255, 255)
  xdid -a %D 16 0 $Rgb(0, 0, 0)
  xdid -a %D 16 0 $Rgb(255, 0, 0)
  xdid -a %D 16 0 $Rgb(128, 0, 0)
  xdid -c %D 16 $MainSettings(FONT, COLOR_COMBO)

  ; Edit preview box.
  xdid -c %D 11 738 edit 238 30 147 77 multi center
  xdid -a %D 738 $+(Moschino, $Crlf, [FlashBuzzen]2.36, $Crlf, A connection $+ $Chr(44), $Crlf, By Dabba)

  ; Check boxes.
  xdid -c %D 11 22 check 238 107 82 25
  xdid -c %D 11 23 check 238 126 50 25 
  xdid -c %D 11 24 check 238 145 50 25
  xdid -t %D 22 Random color
  xdid -t %D 23 Italic
  xdid -t %D 24 Bold
  if ($MainSettings(FONT, RANDOMC) == 1) {
    xdid -c %D 22
    xdid -b %D 16
  }
  if ($MainSettings(FONT, ITALIC) == 1) xdid -c %D 23
  if ($MainSettings(FONT, BOLD) == 1) xdid -c %D 24

  ; Check box.
  xdid -c %D 11 78 check 4 259 150 25
  xdid -t %D 78 Don't use any custom font
  if ($MainSettings(FONT, DONT_USE) == 1) {
    xdid -c %D 78

    xdid -b %D 15
    xdid -b %D 16
    xdid -b %D 22
    xdid -b %D 23
    xdid -b %D 24
    xdid -b %D 738
  }

  ; Box control.
  xdid -c %D 11 30 box 4 167 381 85 multi
  xdid -t %D 30 Font details
  xdid -c %D 30 83738 text 11 26 24 20
  xdid -c %D 30 83739 text 9 49 26 20
  xdid -t %D 83738 Font:
  xdid -t %D 83739 Style:
  xdid -c %D 30 453 edit 42 23 333 22
  xdid -c %D 30 454 edit 42 47 333 22

  ; Button.
  xdid -c %D 11 847 button 284 257 100 25
  xdid -l %D 847 16
  xdid -w %D 847 +n 0 Icons/Settings.ico
  xdid -t %D 847 Save font data

  ; Button.
  xdid -c %D 11 848 button 186 257 95 25
  xdid -l %D 848 16
  xdid -w %D 848 +n 0 Icons/Settings.ico
  xdid -t %D 848 Refresh fonts

  ; Font.
  xdid -f %D 15,22,23,24,30,83738,83739,847,848,78,453,454 +a ansi 8 Tahoma

  Preview_Font

  ; List fonts if Fonts.dat exists
  if ($Isfile(data\Fonts.dat)) List_Fonts
}

alias List_Fonts {
  xdid -r Moschino 15

  .filter -k data\Fonts.dat Load_Font
}

alias Load_Font {
  tokenize 61 $1-

  if ($Readini(data\Fonts.dat, FONTS_ $+ $Win_Key, $1)) {
    xdid -a Moschino 15 0 0 + 0 0 0 0 0 0 $2
  }
}

alias Reg_Read {
  var %Call = REGREAD. $+ $Ticks, %c

  .comopen %Call WScript.Shell

  if (!$Comerr) {
    var %b = $Com(%Call, RegRead, 3, bstr, $1-), %Res = $Com(%Call).result

    .comclose %Call
  }

  return $Iif(%Res, $Ifmatch, Error)
}

alias Win_Key {
  if ($Os isin 9598ME && $Reg_Read(HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\ProductID)) || $&
    ($Reg_Read(HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProductID)) { 

    return $Md5($V1) 
  }
}

alias Store_Fonts {
  var %Key = HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\\Fonts, $&
    %Fonts_Dir = $Reg_Read(%Key)

  if (!$Isdir(%Fonts_Dir)) {
    %Fonts_Dir = " $+ $Sdir(C:\, Please choose your fonts folder $Chr(40) $+ usually C:\Windows\Fonts $+ $chr(41)) $+ "
  }

  if (!$Isdir(%Fonts_Dir)) || (%Fonts_Dir == ERROR) {
    echo -ae * Couldn't locate the fonts folder on your machine, sorry.
    return
  }

  var %s = $Findfile(%Fonts_Dir $+ \, *.ttf, 0, Safe_Font " $+ $1- $+ ")

  echo -ae * Finshed loading your system fonts. You can now set your main script font by re-opening the Moschino setup dialog.

  if ($Dialog(Moschino)) dialog -x Moschino
}

alias Safe_Font {
  var %Font = $Truetype($1-).fullname, %FontStrip = $Replace($Truetype($1-).fullname, $Chr(32), \b))

  if (%Font != $Null) && (%FontStrip != $Null) {
    writeini $+(", $Mircdirdata\Fonts.dat, ") FONTS_ $+ $Win_Key %FontStrip %Font
  }
}

alias Preview_Font {
  var %D = Moschino, %Fontstyle = +a, %Color = $MainSettings(FONT, COLOR), %Font = $MainSettings(FONT, FONTNAME), $&
    %Italic = $MainSettings(FONT, ITALIC), %Bold = $MainSettings(FONT, BOLD), %Color = $MainSettings(FONT, COLOR), $&
    %RandomC = $MainSettings(FONT, RANDOMC)

  var %Style_Selection

  if (%Bold == 1) && (%Italic == 1) { %Fontstyle = +abi | %Style_Selection = Bold, Italic, }
  elseif (%Bold == 1) && (%Italic == 0) { %Fontstyle = +ab | %Style_Selection = Bold, }
  elseif (%Bold == 0) && (%Italic == 1) { %Fontstyle = +ai | %Style_Selection = Italic, }
  elseif (%Bold == 0) && (%Italic == 0) %Fontstyle = +a

  if (%RandomC == 1) %Style_Selection = %Style_Selection $+ Random colors

  if ($Dialog(Moschino)) {
    xdid -f %D 738 %Fontstyle ansi 10 %Font
    xdid -C %D 738 +t %Color

    xdid -o %D 453 %Font
    xdid -o %D 454 %Style_Selection
  }
}

alias Show_Font_Selection {
  var %D = Moschino, %Font = $Hget(FONT, FONTNAME), %Color = $Hget(FONT, COLOR), $&
    %RandomC = $Hget(FONT, RANDOM_COLOR), %Italic = $Hget(FONT, ITALIC), %Bold = $Hget(FONT, BOLD)

  if (%Font == $Null) %Font = $MainSettings(FONT, FONTNAME)
  if (%Color == $Null) %Color = $MainSettings(FONT, COLOR)
  if (%RandomC == $Null) %RandomC = $MainSettings(FONT, RANDOMC)
  if (%Italic == $Null) %Italic = $MainSettings(FONT, ITALIC)
  if (%Bold == $Null) %Bold = $MainSettings(FONT, BOLD)

  var %Fontstyle = +a, %Style_Selection

  if (%Bold == 1) && (%Italic == 1) { %Fontstyle = +abi | %Style_Selection = Bold, Italic, }
  elseif (%Bold == 1) && (%Italic == 0) { %Fontstyle = +ab | %Style_Selection = Bold, }
  elseif (%Bold == 0) && (%Italic == 1) { %Fontstyle = +ai | %Style_Selection = Italic, }
  elseif (%Bold == 0) && (%Italic == 0) { %Fontstyle = +a }

  if (%RandomC == 1) %Style_Selection = %Style_Selection $+ Random colors

  if ($Dialog(Moschino)) {
    xdid -f %D 738 %Fontstyle ansi 10 %Font
    xdid -C %D 738 +t %Color

    xdid -o %D 453 %Font
    xdid -o %D 454 %Style_Selection
  }
}

; Credits to Kamek for these 2 aliases - http://www.mircscripts.org/
alias truetype {
  if (!$isfile($1)) { return }
  var %fn = $iif(("*" iswm $1), $1, $+(", $1, ")), %ntables, %i = 1, %p, %namepos, %namelen, %nid = 1
  if ($findtok(copyright family subfamily id fullname version postscript trademark manufacturer designer - urlvendor urldesigner, $prop, 32)) { %nid = $calc($ifmatch - 1) }
  bread %fn 0 8192 &font
  if ($bvar(&font, 1, 4) != 0 1 0 0) { return }
  %ntables = $bvar(&font, 5).nword
  while (%i <= %ntables) {
    %p = $calc(13 + (%i - 1) * 16)
    if (%p > 8192) { return }
    if ($bvar(&font, %p, 4).text === name) { %namepos = $bvar(&font, $calc(%p + 8)).nlong | %namelen = $bvar(&font, $calc(%p + 12)).nlong | break }
    inc %i
  }
  if (!%namepos) { return }
  if (%namelen > 8192) { %namelen = 8192 }
  bread %fn %namepos %namelen &font
  var %nrecs = $bvar(&font, 3).nword, %storepos = $calc(%namepos + $bvar(&font, 5).nword), %i = 1
  while (%i <= %nrecs) {
    %p = $calc(7 + (%i - 1) * 12)
    if ($bvar(&font, %p).nword = 3) && ($bvar(&font, $calc(%p + 6)).nword = %nid) {
      var %len = $bvar(&font, $calc(%p + 8)).nword, %peid = $bvar(&font, $calc(%p + 2)).nword
      bread %fn $calc(%storepos + $bvar(&font, $calc(%p + 10)).nword) %len &font
      return $uni2ansi($bvar(&font, 1, %len))
    }
    inc %i
  }
}

alias uni2ansi {
  var %unicode = $1, %i = 1, %t = $numtok(%unicode, 32), %s = i, %c
  while (%i <= %t) {
    %c = $gettok(%unicode, $+(%i, -, $calc(%i + 2)), 32)
    if ($gettok(%c, 1, 32) = 0) { %c = $chr($gettok(%c, 2, 32)) }
    else { %c = ? }
    %s = $left(%s, -1) $+ %c $+ i
    inc %i 2
  }
  return $left(%s, -1)
}

alias RGB_To_Hex {
  var %R = $Base($Gettok($Rgb($1), 1, 44), 10, 16, 2), $&
    %G = $Base($Gettok($Rgb($1), 2, 44), 10, 16, 2), $&
    %B = $Base($Gettok($Rgb($1), 3, 44), 10, 16, 2)

  return $+(%R, %G, %B)
}

alias Font_Name return $+(ff:, $MainSettings(FONT, FONTNAME), ;) 

alias Font_Colour {
  var %C = $MainSettings(FONT, Color), %Hex 

  if ($MainSettings(FONT, RANDOMC) == 1) %Hex = $RGB_To_Hex($+($R(0, 255), $R(0, 255), $R(0, 255)))
  else %Hex = $RGB_To_Hex(%C)

  return $+(co:#, %Hex, ;)
}

alias Font_Style {
  var %Italic = $MainSettings(FONT, ITALIC), %Bold = $MainSettings(FONT, BOLD)

  if (%Bold == 1) && (%Italic == 1)  return b;i;
  elseif (%Bold == 1) && (%Italic == 0) return b;
  elseif (%Bold == 0) && (%Italic == 1) return i;
  elseif (%Bold == 0) && (%Italic == 0) return $Null
}

; [style ff:Courier New;co:#808000;b;i;]ghghh[/style]

alias Web_Font return $+(:[Style, $Chr(32), $Font_Name, $Font_Colour, $Font_Style, ]) $+ $1- $+ [/style]

; -- Connection options panel and events

alias Connection_Options_Panel {
  var %D = $$1

  ; Box control.
  xdid -c %D 795 657 box 4 4 180 57
  xdid -t %D 657 Connection options

  xdid -c %D 657 4948 check 7 13 170 24
  xdid -t %D 4948 Login with passport password

  xdid -c %D 657 4949 check 7 31 170 24
  xdid -t %D 4949 Login with passport ticket

  ; Box control.
  xdid -c %D 795 826 box 182 4 202 57
  xdid -t %D 826 Channel idle

  ; Check box.
  xdid -c %D 826 643 check 7 15 70 20
  xdid -t %D 643 Idle mode
  if ($MainSettings(CONNECTION, IDLE_SCAN) == 1) xdid -c %D 643

  ; Text control.
  xdid -c %D 826 856 text 7 36 111 18
  xdid -t %D 856 Trigger idle scan every

  ; Edit control.
  xdid -c %D 826 876 edit 121 29 40 22

  ; Updown control.
  xdid -c %D 826 866 updown 180 70 80 20 buddyint
  xdid -r %D 866 1 30
  xdid -c %D 866 876
  xdid -v %D 866 $MainSettings(CONNECTION, CHANNEL_IDLE_SCAN)
  if ($MainSettings(CONNECTION, IDLE_SCAN) == 0) {
    xdid -b %D 866
    xdid -b %D 876
  }

  ; Text control.
  xdid -c %D 826 896 text 167 36 30 18 
  xdid -t %D 896 (mins)

  if ($MainSettings(CONNECTION, USE_PASSWORD) == 1) xdid -c %D 4948
  if ($MainSettings(CONNECTION, USE_TICKET) == 1) xdid -c %D 4949

  ; Box control.
  xdid -c %D 795 264 box 4 65 380 91
  xdid -t %D 264 Whisper events

  xdid -c %D 264 312 check 7 13 130 30
  xdid -t %D 312 Auto whisper user back
  if ($MainSettings(EVENTS, AUTO_WHISPER_USERS) == 1) xdid -c %D 312

  xdid -c %D 264 313 edit 143 17 231 19 autohs
  xdid -a %D 313 $MainSettings(EVENTS, AUTO_WHISPER_MSG)
  if ($MainSettings(EVENTS, AUTO_WHISPER_USERS) == 0) xdid -b %D 313

  xdid -c %D 264 314 check 7 36 220 31
  xdid -t %D 314 Auto close whisper windows within mIRC
  if ($MainSettings(EVENTS, CLOSE_WHISPER_WINDOWS) == 1) xdid -c %D 314

  xdid -c %D 264 315 check 7 59 250 30
  xdid -t %D 315 Completely disable script whispers (like webchat)
  if ($MainSettings(EVENTS, DISABLE_WHISPERS) == 1) xdid -c %D 315

  ; Box control.
  xdid -c %D 795 269 box 4 159 380 73
  xdid -t %D 269 Auto channel creation

  xdid -c %D 269 411 check 7 13 220 31
  xdid -t %D 411 Auto create channels which don't exist in:
  if ($MainSettings(CONNECTION, AUTO_CHANNEL_CREATION) == 1) xdid -c %D 411

  xdid -c %D 269 412 comboex 233 17 143 100 dropdown
  xdid -a %D 412 0 0 0 0 0 Unlisted=UN
  xdid -a %D 412 0 0 0 0 0 General=GN
  xdid -a %D 412 0 0 0 0 0 Romance=RM
  xdid -a %D 412 0 0 0 0 0 Computing=CP
  xdid -a %D 412 0 0 0 0 0 Peers=PR
  xdid -a %D 412 0 0 0 0 0 Interests=IN
  xdid -a %D 412 0 0 0 0 0 News & events=NE
  xdid -a %D 412 0 0 0 0 0 Sport & politics=SP
  xdid -a %D 412 0 0 0 0 0 City Chats=CC
  xdid -a %D 412 0 0 0 0 0 Lifestyles=LS
  xdid -a %D 412 0 0 0 0 0 Entertainment=ET
  xdid -a %D 412 0 0 0 0 0 Religion=RL
  xdid -c %D 412 $MainSettings(CONNECTION, AUTO_CREATION_CATEGORY)
  if ($MainSettings(CONNECTION, AUTO_CHANNEL_CREATION) == 0) xdid -b %D 412

  xdid -c %D 269 474 text 7 48 60 15
  xdid -t %D 474 Topic/onjoin:
  xdid -c %D 269 6438 edit 71 46 160 19 autohs
  xdid -a %D 6438 $MainSettings(CONNECTION, ROOM_CREATION_TOPIC)
  xdid -c %D 269 7845 edit 233 46 142 19 autohs
  xdid -a %D 7845 $MainSettings(CONNECTION, ROOM_CREATION_ONJOIN)
  if ($MainSettings(CONNECTION, AUTO_CHANNEL_CREATION) == 0) {
    xdid -b %D 6438,7845
  }

  ; Box control.
  xdid -c %D 795 270 box 4 235 380 47
  xdid -t %D 270 General navigation

  xdid -c %D 270 600 text 7 22 80 15
  xdid -t %D 600 Server/port/link:
  xdid -c %D 270 601 edit 90 19 142 19
  xdid -a %D 601 $MainSettings(CONNECTION, IRC_SERVER_PORT)

  xdid -c %D 270 801 edit 233 19 142 19
  xdid -a %D 801 $MainSettings(CONNECTION, WEBLINK)

  ; Font.
  xdid -f %D 657,4948,4949,264,312,313,314,315,269,411,412,270,600,601,801,826,856,876,896,643,474,6438,7845 +a ansi 8 Tahoma
}

; -- Mass joiner panel and events

alias Massjoin_Panel {
  var %D = $$1

  ; Listview control.
  xdid -c %D 386 927 listview 4 26 381 230 report grid borderselect flatsb fullrow
  xdid -t %D 927 +l 0 180 Channels (right-click channels) $Chr(9) +l 0 250 Note
  xdid -l %D 927 16
  xdid -w %D 927 +n 0 Icons/tick.ico

  xdid -c %D 386 903 check 5 3 220 20
  xdid -t %D 903 Auto join ticked channels on start
  if ($MainSettings(AUTO_JOIN_CHANNELS_ON_START, JOIN) == 1) xdid -c %D 903

  xdid -c %D 386 490 button 198 260 60 23
  xdid -t %D 490 Add new

  xdid -c %D 386 491 button 261 260 60 23
  xdid -t %D 491 Join all

  xdid -c %D 386 492 button 324 260 60 23
  xdid -t %D 492 Ok

  List_Mass_Channels

  ; Font.
  xdid -f %D 927,903,490,491,492 +a ansi 8 Tahoma
}

alias Total_Mass_Channels return $Ini(Data/GlobalSettings.ini, MASS_JOIN, 0)

alias List_Mass_Channels {
  var %D = Moschino, %x 1, %File = data\GlobalSettings.ini, %Section = MASS_JOIN

  xdid -r %D 927

  while (%x <= $Total_Mass_Channels) {
    var %Chan = $Ini(%File, %Section, %x), %Icon = $Iif($MainSettings(AUTO_JOIN, %Chan) == TRUE, 1, 0)

    if ($Dialog(%D)) xdid -a Moschino 927 0 0 + %Icon 0 0 0 -1 -1 %Chan $Chr(9) + 0 0 0 $Gettok($MainSettings(MASS_JOIN, %Chan), 1-, 32)
    inc %x
  }
}

alias Mass_Join_Channels {
  var %x 1, %File = data\GlobalSettings.ini, %Section = MASS_JOIN

  while (%x <= $Ini(%File, %Section, 0)) {
    var %Chan = $Ini(%File, %Section, %x)

    if (!$Sock($C_Sock(%Chan))) && (!$Chan(%Chan)) {

      que 2000 JOIN $Chr(37) $!+ $Mid(%Chan, 2)
    }

    inc %x
  }
}

alias Auto_Join_Channels {
  var %x 1, %File = data\GlobalSettings.ini, %Section = AUTO_JOIN

  while (%x <= $Ini(%File, %Section, 0)) {
    var %Chan = $Ini(%File, %Section, %x)

    if (!$Sock($C_Sock(%Chan))) && (!$Chan(%Chan)) {

      que 2000 JOIN $Chr(37) $!+ $Mid(%Chan, 2)
    }

    inc %x
  }
}

; -- Channel scanner panel and events

alias ChannelScanner_Panel {
  var %D = $$1

  ; Listview control.
  xdid -c %D 528 529 listview 4 24 381 230 report grid borderselect flatsb fullrow
  xdid -t %D 529 +l 0 150 Username $Chr(9) +l 0 250 Address $Chr(9) +l 0 160 Tag
  xdid -l %D 529 16
  xdid -w %D 529 +n 0 Icons/owner.ico
  xdid -w %D 529 +n 0 Icons/host.ico
  xdid -w %D 529 +n 0 Icons/helpop.ico

  ; Text control.
  xdid -c %D 528 530 text 4 264 110 30
  xdid -t %D 530 Channel (IRC format):

  ; Edit control.
  xdid -c %D 528 531 edit 117 260 200 22 autohs
  xdid -a %D 531 $Chr(37) $+ #Roomname\bhere

  ; Button.
  xdid -c %D 528 532 button 320 260 64 23
  xdid -t %D 532 Scan

  ; Check boxes.
  xdid -c %D 528 111 check 4 1 64 23
  xdid -t %D 111 Use guest

  xdid -c %D 528 112 check 77 1 94 23
  xdid -t %D 112 Use passport

  if ($MainSettings(CHANNEL_SCAN, USE_GUEST) == 1) xdid -c %D 111
  if ($MainSettings(CHANNEL_SCAN, USE_PASSPORT) == 1) xdid -c %D 112

  ; Font.
  xdid -f %D 529,530,531,532,111,112 +a ansi 8 Tahoma
}

alias Channel_Scan {
  var %C = $1

  if (!%C) { echo -ae * You didn't specify any channel to scan. | return }

  var %Sock = $+(CHANNEL_SCAN., $Numb(10))

  tokenize 58 $MainSettings(CONNECTION, IRC_SERVER_PORT)

  sockopen %Sock $1 $2
  sockmark %Sock %C $Numb(10)
}

on *:SOCKOPEN:CHANNEL_SCAN.*: {
  if ($Sockerr) { 
    echo -ae * Error on socket ; $Sockname $Sockerr $Sock($Sockname).wsmsg
    return  
  }
  var %Pass = $Gettok($MainSettings(BUZZEN_PASSPORTS, $CurrentEmail), 1, 32), $&
    %Sw = sockwrite -n $Sockname

  %Sw USER :BelisknerV.3

  if ($MainSettings(CHANNEL_SCAN, USE_PASSPORT) == 1) {
    if ($CurrentEmail) {
      if ($MainSettings(CONNECTION, USE_TICKET) == 1) %Sw UTICKET $MainSettings($CurrentEmail, TICKET)
      elseif ($MainSettings(CONNECTION, USE_PASSWORD) == 1) %Sw LOGINH $CurrentEmail $Md5(%Pass)
    }
    else echo -ae * You don't have a current passport selected.
  }

  %Sw NICK $Gettok($Sock($Sockname).mark, 2, 32))
}

on *:SOCKREAD:CHANNEL_SCAN.*:{
  if ($Sockerr > 0) return

  var %Chan, %Sw = sockwrite -n $Sockname, %Sm = $Sock($Sockname).mark, %Sw = sockwrite -n $Sockname, $&
    %C = $Gettok(%Sm, 1, 32), %Nick = $Gettok(%Sm, 2, 32)

  sockread %Chan

  tokenize 32 %Chan

  ;echo -a $Sockname ; $1-

  if ($2 == 001) %Sw NICK $Numb(10) $+ $Crlf $+ JOIN %C

  elseif ($2 == JOIN) %Sw WHO %C

  elseif ($2 == 352) {
    if ($8 != %Nick) .signal -n $Sockname $5-
  }

  elseif ($Regex($2, 315|403|433)) {
    if ($2 == 315) .signal -n CHANNEL_SCAN_FINISHED
    sockclose $Sockname
  }

  :error
  if ($Error) reseterror
}

on *:SIGNAL:CHANNEL_SCAN.*: {
  if ($Dialog(Moschino)) {
    var %Bracks, %Icon

    if (* isin $5) { %Bracks = Staff | %Icon = 1 } 
    elseif (' isin $5) { %Bracks = Superowner | %Icon = 1 }
    elseif (. isin $5) { %Bracks = Owner | %Icon = 1 }
    elseif (@ isin $5) { %Bracks = Host | %Icon = 2 }
    elseif ($(%, ) isin $5) { %Bracks = Helpop | %Icon = 3 }
    else { %Bracks = Regular | %Icon = 0 }

    xdid -a Moschino 529 0 0 + %Icon 0 0 0 -1 -1 $Buzz.decode($4) $RBracks(%Bracks) $Chr(9) + 0 0 0 $+($1, @, $2) $&
      $Chr(9) + 0 0 0 $7-
  }
}

on *:SIGNAL:CHANNEL_SCAN_FINISHED: {
  if ($Dialog(Moschino)) xdid -z Moschino 529 +cd 1 Sort_Alg
}

alias Sort_Alg {
  if (*owner* iswm $1) && (*staff* iswm $2) return -1
  elseif (*host* iswm $1) && (*staff* iswm $2) return -1
  elseif (*helpop* iswm $1) && (*staff* iswm $2) return -1
  elseif (*regular* iswm $1) && (*staff* iswm $2) return -1

  elseif (*owner* iswm $1) && (*superowner* !iswm $1) && (*superowner* iswm $2) return -1
  elseif (*host* iswm $1) && (*superowner* iswm $2) return -1
  elseif (*helpop* iswm $1) && (*superowner* iswm $2) return -1
  elseif (*regular* iswm $1) && (*superowner* iswm $2) return -1

  elseif (*host* iswm $1) && (*owner* iswm $2) return -1
  elseif (*helpop* iswm $1) && (*owner* iswm $2) return -1
  elseif (*regular* iswm $1) && (*owner* iswm $2) return -1

  elseif (*helpop* iswm $1) && (*host* iswm $2) return -1
  elseif (*regular* iswm $1) && (*host* iswm $2) return -1

  elseif (*regular* iswm $1) && (*helpop* iswm $2) return -1

  ;---

  elseif (*staff* iswm $1) && (*owner* iswm $2) return 1
  elseif (*staff* iswm $1) && (*host* iswm $2) return 1
  elseif (*staff* iswm $1) && (*helpop* iswm $2) return 1
  elseif (*staff* iswm $1) && (*regular* iswm $2) return 1

  elseif (*superowner* iswm $1) && (*owner* iswm $2) return 1
  elseif (*superowner* iswm $1) && (*host* iswm $2) return 1
  elseif (*superowner* iswm $1) && (*helpop* iswm $2) return 1
  elseif (*superowner* iswm $1) && (*(-)* iswm $2) return 1

  elseif (*owner* iswm $1) && (*host* iswm $2) return 1
  elseif (*owner* iswm $1) && (*helpop* iswm $2) return 1
  elseif (*owner* iswm $1) && (*(-)* iswm $2) return 1

  elseif (*host* iswm $1) && (*helpop* iswm $2) return 1
  elseif (*host* iswm $1) && (*(-)* iswm $2) return 1

  elseif (*helpop* iswm $1) && (*(-)* iswm $2) return 1

  else return 0
}

; -- Channel scanner panel and events

alias Nicklogger_Panel {
  var %D = $$1

  ; Listview control.
  xdid -c %D 837 286 listview 4 51 381 205 report grid borderselect flatsb fullrow
  xdid -t %D 286 +l 0 150 Address $Chr(9) +l 0 250 Nickname logs (right-click entries)
  xdid -l %D 286 16
  xdid -w %D 286 +n 0 Icons/user.ico

  ; Text control.
  xdid -c %D 837 363 text 4 264 103 30
  xdid -t %D 363 Search for nick/gate:

  ; Edit control.
  xdid -c %D 837 4379 edit 107 260 220 22 autohs

  ; Button.
  xdid -c %D 837 16895 button 330 260 54 23
  xdid -t %D 16895 Scan

  ; Check boxes.
  xdid -c %D 837 5436 check 4 1 104 23
  xdid -t %D 5436 Enable nicklogging

  xdid -c %D 837 5437 check 120 1 78 23
  xdid -t %D 5437 Msg nicklogs
  xdid -c %D 837 5438 check 207 1 94 23
  xdid -t %D 5438 Echo nicklogs

  xdid -c %D 837 5439 check 4 25 233 23
  xdid -t %D 5439 Limit number of nickname logs per address to

  xdid -c %D 837 5321 edit 241 25 40 22
  xdid -c %D 837 5322 updown 254 20 80 20 buddyint
  xdid -r %D 5322 5 40
  xdid -c %D 5322 5321
  xdid -v %D 5322 $MainSettings(NICKLOGGER, LIMIT)
  xdid -c %D 837 5323 text 285 29 55 18 
  xdid -t %D 5323 nicknames.

  if ($MainSettings(NICKLOGGER, DO_NICKLOGGING) == 1) xdid -c %D 5436
  if ($MainSettings(NICKLOGGER, MSG) == 1) xdid -c %D 5437
  if ($MainSettings(NICKLOGGER, ECHO) == 1) xdid -c %D 5438

  if ($MainSettings(NICKLOGGER, DO_NICKLOGGING) == 0) {
    xdid -b %D 5437,5438
  }

  if ($MainSettings(NICKLOGGER, DO_LIMIT) == 1) xdid -c %D 5439
  if ($MainSettings(NICKLOGGER, DO_LIMIT) == 0) xdid -b %D 5321

  ; Font.
  xdid -f %D 286,363,4379,16895,5436,5437,5438,5439,5321,5322,5323 +a ansi 8 Tahoma
}

on *:JOIN:#: {
  if ($MainSettings(NICKLOGGER, DO_NICKLOGGING) == 1) {
    if (!$Is_Guest($Nick)) && ($Nick != $Me) {
      Log_Nick $Address $Nick

      var %Entry = $Format_Entry($Read(data\Nicklog.txt, sn, $Address)), $&
        %Data = * Nicklog: $Nick .. %Entry $RBracks($Numtok(%Entry, 44) nick[s])

      if ($MainSettings(NICKLOGGER, MSG) == 1) msg # %Data
      if ($MainSettings(NICKLOGGER, ECHO) == 1) echo -ec Other # %Data
    }
  }
}

alias Format_Entry return $Replace($1-, $Chr(32), $Chr(44) $+ $Chr(32))

alias Log_Nick {
  var %File = data\Nicklog.txt, %Entry = $Read(%File, sn, $1)

  if (!%Entry) write %File $1 $2

  else {
    if ($MainSettings(NICKLOGGER, DO_LIMIT) == 1) {
      var %Limit = $MainSettings(NICKLOGGER, LIMIT), %Total = $Numtok(%Entry, 32), $&
        %Numb = $+(-, $Calc(%Limit - 1), -)

      if (%Total >= %Limit) {
        write -l $+ $Readn %File $1 $Gettok(%Entry, %Numb, 32) $2
        return 
      }
    }

    write -l $+ $Readn %File $1 $Addtok(%Entry, $2, 32)
  }
}

alias Nick_Check {
  var %File = data\Nicklog.txt

  if ($1 == CHANNEL) {
    var %x 1

    while (%x <= $Nick($2, 0)) {
      var %Nick = $Nick($2, %x), %GKP = $Ial(%Nick).addr, %Entry = $Read(%File, sn, %GKP)

      if (%Nick != $Me) && (!$Is_Guest(%Nick)) {
        echo $2 * 4 $+ %Nick  .. $Iif(!%Entry, No logged nicks., $Format_Entry(%Entry))
      }

      inc %x
    }

    echo -e $2 * Checked $Calc($Nick($2, 0) - 1) nick[s] out of $Lines(%File) entries.  | /splay clones_d.wav
  }

  elseif ($1 == MULTI) {
    var %Nicks = $2-, %Total = $Numtok(%Nicks, 32)

    echo -ae * Checking nicklogs on: %Nicks $RBracks(%Total nick[s]) )

    var %x 1
    while (%x <= %Total) {
      var %Nick = $Gettok(%Nicks, %x, 32), %Ial = $Ial(%Nick).addr

      if (%Ial) {
        var %Entry = $Read(%File, sn, %Ial)

        echo -a * 04 $+ %Nick .. $Format_Entry(%Entry) $RBracks($Numtok(%Entry, 32) nick[s]) )
      }
      else echo -a * No IAL stored for %Nick $+ .

      inc %x
    }

    echo -ae * Finished checking nicknames.
  }

  elseif ($1 == DIALOG) {
    var %Search = $$2

    if ($Len(%Search) <= 3) {
      var %Prompt = $Input(Your search criteria is only $Ifmatch char(s) long. If your Nicklog.txt contains many entries then $&
        this could possibly lock your mIRC up for some period. Would you like to continue?, in, Nicklog wildcard search)

      if (%Prompt == $False) return
    }

    xdid -r Moschino 286

    var %Start = 0, %Nr = 0, %Ln = $Read(%File, w, $+(*, %Search, *), 0)

    while (%Ln) {
      inc %Nr

      tokenize 32 %Ln

      xdid -a Moschino 286 0 0 + 1 0 0 0 0 0 $1 $Chr(9) -2 0 0 0 $Buzz.decode($Format_Entry($2-))

      %Start = $Calc($Readn + 1)

      %Ln = $Read(%File, w, $+(*, %Search, *), %Start)
    }

    $Input(Found %Nr matche(s) out of $Lines(%File) logs!, o, Scan complete)
  }
}

; -- Chatlister

dialog ChatLister {
  title "Moschino[FlashBuzzen] channel lister.."
  size -1 -1 311 177
  option dbu
}

on *:DIALOG:ChatLister:INIT:0:{
  var %D = $Dname

  dcx Mark %D ChannelListing_Callback

  ; Border.
  xdialog -b %D +woty

  ; Category.
  xdialog -c %D 1 text 3 7 62 16
  xdid -t %D 1 Category:
  xdialog -c %D 2 comboex 55 4 140 160 dropdown
  xdid -a %D 2 0 0 0 0 0 Unlisted=UN
  xdid -a %D 2 0 0 0 0 0 General=GN
  xdid -a %D 2 0 0 0 0 0 Romance=RM
  xdid -a %D 2 0 0 0 0 0 Computing=CP
  xdid -a %D 2 0 0 0 0 0 Peers=PR
  xdid -a %D 2 0 0 0 0 0 Interests=IN
  xdid -a %D 2 0 0 0 0 0 News & events=NE
  xdid -a %D 2 0 0 0 0 0 Sport & politics=SP
  xdid -a %D 2 0 0 0 0 0 City Chats=CC
  xdid -a %D 2 0 0 0 0 0 Lifestyles=LS
  xdid -a %D 2 0 0 0 0 0 Entertainment=ET
  xdid -a %D 2 0 0 0 0 0 Religion=RL
  xdid -c %D 2 2

  ; Page listings.
  xdialog -c %D 3 text 310 7 300 16
  xdid -t %D 3 Some categories have more than 1 page of listing:
  xdialog -c %D 4 comboex 552 4 70 150 dropdown

  ; Sort by.
  xdialog -c %D 5 text 305 312 60 16
  xdid -t %D 5 Sort by:
  xdialog -c %D 55 comboex 345 308 120 150 dropdown
  xdid -a %D 55 0 0 0 0 0 Chatroom name
  xdid -a %D 55 0 0 0 0 0 Number of users
  xdid -a %D 55 0 0 0 0 0 Topic

  ; Sort order.
  xdialog -c %D 56 text 478 312 60 16
  xdid -t %D 56 Sort order:
  xdialog -c %D 57 comboex 532 308 90 150 dropdown
  xdid -a %D 57 0 0 0 0 0 Ascending
  xdid -a %D 57 0 0 0 0 0 Descending

  ; Listview control.
  xdialog -c %D 6 listview 2 31 619 270 report grid borderselect flatsb fullrow
  xdid -t %D 6 +l 0 200 Channel (right-click channels) $Chr(9) +l 0 260 Topic $Chr(9) +l 0 70 Users $Chr(9) +l 0 85 Language
  xdid -l %D 6 16
  xdid -w %D 6 +n 0 Icons/rmicon_srv.ico
  xdid -w %D 6 +n 0 Icons/rmicon_user.ico

  ; Link.
  xdialog -c %D 11 text 4 312 180 23
  xdid -t %D 11 $MainSettings(CONNECTION, LINK)
  xdid -f %D 11 +au ansi 8 Verdana
  xdid -C %D 11 +t $Rgb(0, 0, 255)

  ; Statusbar.
  xdialog -c %D 13 statusbar 140 30 100 20 grip tooltips
  xdid -w %D 13 +n 0 Icons/rmicon_srv.ico
  xdid -w %D 13 +n 0 Icons/rmicon_user.ico

  xdid -l %D 13 200 400 800 -1
  xdid -f %D 13 +a ansi 8 Verdana
  xdid -v %D 13 1 Channel lister on stand by..
  xdid -t %D 13 2 + 1 Buzzen sanctioned channel
  xdid -t %D 13 3 + 2 Registered user chat room

  ; Font.
  xdid -f %D 1,2,3,4,5,6,55,56,57 +a ansi 8 Tahoma
}

alias ChannelListing_Callback {
  if ($2 == SCLICK) {

    ;echo -a $1-

    if ($3 == 2) {
      tokenize 61 $xdid($1, $3, $4).text

      List /roomslist.aspx?cat= $+ $2

      xdid -r ChatLister 6
      xdid -r ChatLister 4

      xdid -c ChatLister 55 1
      xdid -c ChatLister 57 1
    }

    elseif ($3 == 11) RUN $xdid($1, 11).text

    elseif ($3 == 4) {
      xdid -r ChatLister 6
      xdid -r ChatLister 4

      List $Hget(Chatlist, $4)
    }

    elseif ($3 == 55) {
      xdid -r ChatLister 6
      xdid -r ChatLister 4

      var %Sel = $xdid($1, $3, $4).text

      List /roomslist.aspx?cat= $+ $Gettok($xdid($1, 2).seltext, 2, 61) $+ $SortFlag(%Sel) $+ $SortFlag2($xdid($1, 57).seltext)
    }

    elseif ($3 == 57) {
      xdid -r ChatLister 6
      xdid -r ChatLister 4

      var %Sel = $xdid($1, $3, $4).text

      List /roomslist.aspx?cat= $+ $Gettok($xdid($1, 2).seltext, 2, 61) $+ $SortFlag($xdid($1, 55).seltext) $+ $SortFlag2(%Sel)
    }

    elseif ($3 == 12) dialog -x ChatLister
  }

  elseif ($2 == RCLICK) && ($3 == 6) && ($4-) {
    var %Menu = CHANNELS_LISTVIEW

    if ($xpopup(%Menu).ismenu) xpopup -d %Menu

    xpopup -c %Menu verticalrev 

    xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
      $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
      $Rgb(248, 248, 255)

    xpop -a %Menu 0 $Chr(9) +g 1 0 Channel: $($xdid(ChatLister, 6, 0).seltext, )
    xpop -a %Menu 0 $Chr(9) + 2 0 -
    xpop -a %Menu 0 $Chr(9) + 3 0 Join this channel
    xpop -a %Menu 0 $Chr(9) + 4 0 Add this channel to massjoin
    xpop -a %Menu 0 $Chr(9) + 5 0 Clipboard this channel

    xpopup -s %Menu + $Mouse.dx $Mouse.dy
  }
}

alias SortFlag {
  var %Sel = $$1, %ID

  if (%Sel == Chatroom name) %ID = name
  elseif (%Sel == Number of users) %ID = users
  elseif (%Sel == Topic) %ID = topic

  return $+(&sortflag=, %ID)
}

alias SortFlag2 {
  var %Sel = $$1, %ID

  if (%Sel == Ascending) %ID = asc
  else %ID = desc

  return $+(&sortflag2=, %ID)
}

alias -l List {
  var %Sock = $+(CHANLIST., $Numb(10))

  sockopen %Sock $MainSettings(CONNECTION, WEBLINK) 80 
  sockmark %Sock $$1
}

on *:SOCKOPEN:CHANLIST.*: {
  if ($Sockerr) { 
    echo -ae * Error at socket ; $Sockname $Sockerr $Sock($Sockname).wsmsg
    return  
  }

  tokenize 32 $Sock($Sockname).mark

  sockwrite -n $Sockname GET $1 HTTP/1.0 $+ $Crlf $+ $&
    Accept: */* $+ $Crlf $+ $&
    Referer: http:// $+  $MainSettings(CONNECTION, WEBLINK) $+ $Crlf $+ $&
    Accept-Language: en-us $+ $Crlf $+ $&
    Accept-Encoding: gzip, deflate $+ $Crlf $+ $&
    User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322) $+ $Crlf $+ $&
    Cookie: $+ $Str($Crlf, 2)
}

on *:SOCKREAD:CHANLIST.*: {
  if ($Sockerr > 0) return

  var %Read, %Cat = $Sock($Sockname).mark
  sockread %Read

  tokenize 32 %Read

  if (!$Dialog(ChatLister)) Open_Dialog ChatLister

  if (*class="rlNavTitle2">Pages:* iswm %Read) {
    var %TotalPages = $Count(%Read, href) + 1, %CP = $Regex(%Read, /\[(.*)\] (\<a href='roomslist.aspx|\<\/td\>)/)

    var %x 1

    while (%x <= %TotalPages) {
      if (!$xdid(ChatLister, 4, $Chr(9) * $+ %x $+ * $Chr(9), W, 0).find) {
        xdid -a ChatLister 4 0 0 0 0 0 Page %x
        hadd -m Chatlist %x $+(/roomslist.aspx?pg=, %x, &cat=, $Right($Sock($Sockname).mark, 2))
      }

      inc %x
    }

    xdid -c ChatLister 4 $Regml(1)
  }

  if ($Regex(%Read, class=\"rmlist\"\>(.*)\<\/a\>.*?\<td\b[^>]*\>(.*?)\<\/td\>\<td\b[^>]*\>(.*?)\<\/td\>\<td\>(.*)\<\/td\>)) {
    var %Chan = $+($(%#, ), $Replace($Regml(1), $Chr(32), \b)), $&
      %Topic =  $Iif($Remove($Regml(2), &nbsp;), $Ifmatch, Unset), $&
      %Users = $Regml(3), $&
      %Language = $Replace($Regml(4), &ccedil;, , &ntilde;, ), $&
      %Icon = $Iif(*rmicon_srv.jpg* iswm %Read, 1, $Iif(*rmicon_user.jpg* iswm %Read, 2, 0))

    xdid -a ChatLister 6 0 0 +c %Icon 0 0 0 $rgb(0, 0, 128) 0 %Chan $Chr(9) + 0 0 0 %Topic $Chr(9) + 0 0 0 %Users $Chr(9) + 0 0 0 %Language
  }

  if (</HTML> isin %Read) .signal -n CHATLISTING_FINISHED

  :error
  if ($Error) reseterror
}

on *:SIGNAL:CHATLISTING_FINISHED: {
  var %Total = $xdid(ChatLister, 6, $Chr(9) * $Chr(9), W, 1, 0).find

  xdid -v ChatLister 13 1 * Captured %Total channel(s)..
}

; -- Channel creator

dialog Channel_creation {
  title "Moschino[FlashBuzzen] channel creation.."
  size -1 -1 184 88
  option dbu
}

on *:DIALOG:Channel_creation:INIT:0:{
  var %D = $Dname

  dcx Mark %D ChannelCreation_Callback

  ; Border.
  xdialog -b %D +woty

  ; Channel name.
  xdialog -c %D 1 text 3 5 72 16
  xdid -t %D 1 Channel name:
  xdialog -c %D 2 edit 80 3 286 20 autohs
  xdid -a %D 2 $(%#!!Dabba's\btest\bchannel, )

  ; Category.
  xdialog -c %D 3 text 25 29 62 16
  xdid -t %D 3 Category:
  xdialog -c %D 4 comboex 80 26 287 160 dropdown
  xdid -a %D 4 0 1 0 0 0 Unlisted=UN
  xdid -a %D 4 0 1 0 0 0 General=GN
  xdid -a %D 4 0 1 0 0 0 Romance=RM
  xdid -a %D 4 0 1 0 0 0 Computing=CP
  xdid -a %D 4 0 1 0 0 0 Peers=PR
  xdid -a %D 4 0 1 0 0 0 Interests=IN
  xdid -a %D 4 0 1 0 0 0 News & events=NE
  xdid -a %D 4 0 1 0 0 0 Sport & politics=SP
  xdid -a %D 4 0 1 0 0 0 City Chats=CC
  xdid -a %D 4 0 1 0 0 0 Lifestyles=LS
  xdid -a %D 4 0 1 0 0 0 Entertainment=ET
  xdid -a %D 4 0 1 0 0 0 Religion=RL
  xdid -c %D 4 2

  ; Language.
  xdialog -c %D 5 text 23 53 62 16
  xdid -t %D 5 Language:
  xdialog -c %D 6 comboex 80 51 287 160 dropdown
  xdid -a %D 6 0 1 0 0 0 Chinese=zh
  xdid -a %D 6 0 1 0 0 0 Arabic=ar
  xdid -a %D 6 0 1 0 0 0 Turkish=tr
  xdid -a %D 6 0 1 0 0 0 Portugus=pt
  xdid -a %D 6 0 1 0 0 0 Malay=ms
  xdid -a %D 6 0 1 0 0 0 Japanese=ja
  xdid -a %D 6 0 1 0 0 0 Italian=it
  xdid -a %D 6 0 1 0 0 0 Indonesian=id
  xdid -a %D 6 0 1 0 0 0 Hindi=hi
  xdid -a %D 6 0 1 0 0 0 Herbrew=he
  xdid -a %D 6 0 1 0 0 0 Finnish=fi
  xdid -a %D 6 0 1 0 0 0 Greek=el
  xdid -a %D 6 0 1 0 0 0 Danish=da
  xdid -a %D 6 0 1 0 0 0 Dutch=nl
  xdid -a %D 6 0 1 0 0 0 English=en
  xdid -a %D 6 0 1 0 0 0 Spanish=es
  xdid -a %D 6 0 1 0 0 0 French=fr
  xdid -a %D 6 0 1 0 0 0 German=de
  xdid -c %D 6 15			

  ; Topic.
  xdialog -c %D 7 text 45 77 32 16
  xdid -t %D 7 Topic:
  xdialog -c %D 8 edit 80 76 286 20 autohs
  xdid -a %D 8 Moschino[FlashBuzzen]2.36 - http://moschino.org.uk

  ; Onjoin.
  xdialog -c %D 9 text 40 101 35 16
  xdid -t %D 9 Onjoin:
  xdialog -c %D 10 edit 80 99 286 20 autohs
  xdid -a %D 10 Welcome to the room rootmonkey! http://moschino.org.uk

  ; Limit.
  xdialog -c %D 11 text 40 125 35 16
  xdid -t %D 11 Limit:
  xdialog -c %D 12 edit 80 123 46 20
  xdid -a %D 12 50

  ; Line.
  xdialog -c %D 13 line 0 137 390 27

  ; Button.
  xdialog -c %D 14 button 264 154 50 23
  xdid -t %D 14 Create
  xdialog -c %D 15 button 317 154 50 23
  xdid -t %D 15 Cancel

  ; Link.
  xdialog -c %D 16 text 5 160 180 23
  xdid -t %D 16 $MainSettings(CONNECTION, LINK)
  xdid -f %D 16 +au ansi 8 Verdana
  xdid -C %D 16 +t $Rgb(0, 0, 255)

  ; Font.
  xdid -f %D 1,2,3,4,5,6,7,8,9,10,11,12,14,15 +a ansi 8 Tahoma
}

alias ChannelCreation_Callback {
  if ($2 == SCLICK) {
    if ($3 == 14) {
      var %Chan = $xdid($1, 2).text, %Category = $Gettok($xdid($1, 4).seltext, 2, 61), $&
        %Language = $Gettok($xdid($1, 6).seltext, 2, 61), %Topic = $xdid($1, 8).text, %Onjoin =  $xdid($1, 10).text, $&
        %Limit = $xdid($1, 12).text

      var %Table = $+(CHANNEL., %Chan)

      hadd -m %Table CATEGORY %Category
      hadd -m %Table LANGUAGE %Language
      hadd -m %Table TOPIC %Topic
      hadd -m %Table ONJOIN %Onjoin
      hadd -m %Table LIMIT %Limit

      if ($Sock(LOCALHOST)) && ($Sock(LOCALHOST).mark == CONNECTED) {

        if ($Chan(%Chan)) {
          echo -ae * There is already a channel %Chan open on your mIRC.
        }

        elseif (%Limit !isnum 0-100) {
          echo -a -
          echo -a * The topic and welcome message can only be 1 word at creation point.
          echo -a * The limit must be a number between 0 and 100.
          echo -a * When you've created the room you can then change the topic or onjoin welcome to whatever you want.
          echo -a -
        }

        else {
          Channel_Create %Chan $Hget(%Table, CATEGORY) $Hget(%Table, LANGUAGE) $Hget(%Table, TOPIC) $&
            $Hget(%Table, ONJOIN) $Hget(%Table, LIMIT)

          if ($Dialog($1)) dialog -x $1
        }
      }
      else echo -ae * You localhost is not set up. Please set it up from your status screen by right-clicking.
    }

    elseif ($3 == 15) dialog -x Channel_creation

    elseif ($3 == 16) RUN $xdid($1, 16).text
  }
}

alias Channel_Create {
  var %Chan = $$1, %Sock = $+(CHANNEL_CREATE., %Chan)

  echo -ae * Attempting to create %Chan in the $2 category, please wait a moment..

  Find_Channel %Chan CREATE
}

; -- Access lister

dialog AccessLister {
  title Moschino[FlashBuzzen] access lister..
  size -1 -1 357 156
  option dbu
}

on *:DIALOG:AccessLister:INIT:0:{
  var %D = $Dname

  dcx Mark %D AccessLister_Callback

  ; Border.
  xdialog -b %D +woty

  ; Listview control.
  xdialog -c %D 1 listview 1 25 712 227 report grid borderselect flatsb fullrow
  xdid -t %D 1 +l 0 70 Access $Chr(9) +l 0 130 User $Chr(9) +l 0 240 Address mask (right-click access entries) $&
    $Chr(9) +l 0 205 Reason $Chr(9) +1 0 83 Expries
  xdid -l %D 1 16
  xdid -w %D 1 +n 0 Icons/owner.ico
  xdid -w %D 1 +n 0 Icons/host.ico

  xdialog -c %D 2 comboex 1 255 110 100 dropdown
  xdid -a %D 2 0 0 0 0 0 Clear all OWNER
  xdid -a %D 2 0 0 0 0 0 Clear all HOST
  xdid -a %D 2 0 0 0 0 0 Clear all DENY
  xdid -a %D 2 0 0 0 0 0 Clear all GRANT
  xdid -a %D 2 0 0 0 0 0 Clear all VOICE
  xdid -a %D 2 0 0 0 0 0 Clear all *
  xdid -c %D 2 1

  xdialog -c %D 3 button 113 255 70 23
  xdid -t %D 3 Go

  xdialog -c %D 4 comboex 200 255 180 100 dropdown
  xdid -a %D 4 0 0 0 0 0 Add a custom OWNER mask
  xdid -a %D 4 0 0 0 0 0 Add a custom HOST mask
  xdid -a %D 4 0 0 0 0 0 Add a custom DENY mask
  xdid -a %D 4 0 0 0 0 0 Add a custom GRANT mask
  xdid -a %D 4 0 0 0 0 0 Add a custom VOICE mask
  xdid -c %D 4 1

  xdialog -c %D 5 button 382 255 70 23
  xdid -t %D 5 Go

  xdialog -c %D 6 button 469 255 120 23
  xdid -t %D 6 Save channel entries

  xdialog -c %D 7 button 593 255 120 23
  xdid -t %D 7 Load access entries

  xdialog -c %D 8 line 1 283 735 5

  xdialog -c %D 9 check 3 2 150 20
  xdid -t %D 9 Access me (every 60 secs)
  if ($MainSettings(CONNECTION, TIMER_ACCESS) == 1) xdid -c %D 9

  xdialog -c %D 99 check 160 2 213 20
  xdid -t %D 99 Save access listing for all channels every
  xdialog -c %D 454 edit 378 2 40 20
  xdialog -c %D 5646 updown 400 70 80 20 buddyint
  xdid -r %D 5646 1 60
  xdid -c %D 5646 454
  xdid -v %D 5646 $MainSettings(CONNECTION, SAVE_ACCESS_INTERVAL)
  xdialog -c %D 896 text 422 5 40 18 
  xdid -t %D 896 (mins)
  if ($MainSettings(CONNECTION, SAVE_ACCESS) == 1) xdid -c %D 99
  if ($MainSettings(CONNECTION, SAVE_ACCESS) == 0) xdid -b %D 454

  xdialog -c %D 10 text 3 293 190 20
  xdid -t %D 10 $MainSettings(CONNECTION, LINK)
  xdid -f %D 10 +au ansi 8 Verdana
  xdid -C %D 10 +t $Rgb(0, 0, 255)

  xdialog -c %D 747 button 609 290 30 23
  xdid -l %D 747 16
  xdid -w %D 747 +n 0 Icons/info.ico

  xdialog -c %D 11 button 642 290 70 23
  xdid -t %D 11 Ok

  ; Font.
  xdid -f %D 1,2,3,4,5,6,7,9,11,99,454,896 +a ansi 8 Tahoma

  if ($C_Sock($Hget(Access, List))) sockwrite -n $Ifmatch ACCESS $Hget(Access, List) LIST
}

alias AccessLister_Callback {

  if ($2 == SCLICK) {
    var %Chan = $Hget(Access, List), %Sw = sockwrite -n $C_Sock(%Chan) ACCESS %Chan

    ;echo -a $1-

    if ($3 == 3) {
      var %Type = $xdid($1, 2).seltext, $&
        %Confirm = $Input(Are you sure you would like to %Type, y, Access removal)

      if (%Confirm) {
        if (%Type == Clear all OWNER) %Sw CLEAR OWNER
        elseif (%Type == Clear all HOST) %Sw CLEAR HOST
        elseif (%Type == Clear all DENY) %Sw CLEAR DENY
        elseif (%Type == Clear all GRANT) %Sw CLEAR GRANT
        elseif (%Type == Clear all VOICE) %Sw CLEAR VOICE
        else %Sw CLEAR
      }

      xdid -r $1 1
      %Sw LIST
    }

    elseif ($3 == 5) {
      var %Type = $xdid($1, 4).seltext, $&
        %Mask = $Input(What mask would you like to add $Gettok(%Type, 4, 32) to?, qe, Access add, *!*someonesaddresshere)

      if (%Mask != $Null) {
        var %Reason = $Input(Enter an access reason.., qe, Access reason, This user is a rootmonkey!)

        if (%Reason != $Null) {
          if (%Type == Add a custom OWNER mask) %Sw ADD OWNER %Mask 0 $+(:, %Reason)
          else if (%Type == Add a custom HOST mask) %Sw ADD HOST %Mask 0 $+(:, %Reason)
          else if (%Type == Add a custom DENY mask) %Sw ADD DENY %Mask 0 $+(:, %Reason)
          else if (%Type == Add a custom GRANT mask) %Sw ADD GRANT %Mask 0 $+(:, %Reason)
          else %Sw ADD VOICE %Mask 0 $+(:, %Reason)

          xdid -r $1 1
          %Sw LIST
        }
      }
    }

    elseif ($3 == 6) {
      if ($Nick($Me, %Chan, '.@)) {
        echo -ae * You must be an owner to save/load access entries.
        return
      }

      var %Schan = $Remove(%Chan, \b, \c), %File = $+(", access_entries/Access_ $+ %SChan $+ .ini, ")

      if ($Isfile(%File)) .remove %File

      var %x 1, %Total = $xdid(AccessLister, 1).num

      while (%x <= %Total) {
        var %Type = $xdid(AccessLister, 1, %x, 0).text, $&
          %Mask = $xdid(AccessLister, 1, %x, 2).text, $&
          %Who = $xdid(AccessLister, 1, %x, 1).text, $&
          %Expiry = $Int($Calc($Duration($xdid(AccessLister, 1, %x, 4).text) / 60)), $&
          %Reason = $xdid(AccessLister, 1, %x, 3).text

        writeini %File %SChan %Mask %Type %Who %Expiry %Reason
        inc %x
      }

      echo -ae * Stored %Total entrie(s) to %File
    }

    elseif ($3 == 7) {
      if ($Nick($Me, %Chan, '.@)) {
        echo -ae * You must be an owner to save/load access entries.
        return
      }

      var %File = " $+ $Sfile($Mircdiraccess_entries/,Please choose your access entry file for your channel) $+ "

      if (%File) {
        var %x 1, %Schan = $Remove(%Chan, \b, \c), %Total = $Ini(%File, %SChan, 0), $&
          %Fchan = $Replace(%Chan, $Eval(%#, 0), $Eval(% $+ #, 0))

        while (%x <= %Total) {
          var %Mask = $Ini(%File, %SChan, %x), %Entry = $Readini(%File, %SChan, %Mask)

          tokenize 32 %Entry

          que 1000 sockwrite -n $C_Sock(%Chan) ACCESS %FChan ADD $1 %Mask $3 : $+ $Iif($4- == None, Loaded access entry for $2 $+ . Set by $Me, $4-)
          que 1000 xdid -r AccessLister 1    
          que 1000 sockwrite -n $C_Sock(%Chan) ACCESS %FChan LIST      
          inc %x
        }

        ;xdid -r $1 1
        ;%Sw LIST
      }
    }

    elseif ($3 == 10) RUN $xdid($1, 10).text
    elseif ($3 == 11) dialog -x $1

    elseif ($3 == 747) {
      $Input(You can highlight multiple access entries in the dialog by holding down the CTRL or SHIFT key!, oi, Removing multiple access entries)
    }
  }

  elseif ($2 == LBDOWN) {
    if ($3 == 9) {
      var %State = $xdid($1, 9).state

      if (%State == 1) {
        MainSettings CONNECTION TIMER_ACCESS 0
        if ($Timer(access)) .timeraccess off
      }
      else { 
        MainSettings CONNECTION TIMER_ACCESS 1
        .timerACCESS 0 60 DoAccess
      }
    }

    elseif ($3 == 99) {
      var %State = $xdid($1, 99).state

      if (%State == 0) {
        MainSettings CONNECTION SAVE_ACCESS 1
        xdid -e $1 454

        Channel_Access
      }

      elseif (%State == 1) {
        MainSettings CONNECTION SAVE_ACCESS 0
        xdid -b $1 454

        Channel_Access
      }
    }
  }

  elseif ($2 == MOUSE) {
    ;echo -a $1-

    if ($3 == 454) || ($3 == 5646) {
      MainSettings CONNECTION SAVE_ACCESS_INTERVAL $xdid($1, 5646).value

      Channel_Access
    }
  }

  elseif ($2 == RCLICK) && ($3 == 1) && ($4-) {
    var %Menu = ACCESS_LISTVIEW

    if ($xpopup(%Menu).ismenu) xpopup -d %Menu

    xpopup -c %Menu verticalrev 

    xpopup -p %Menu $Rgb(255, 255, 255) $Rgb(119, 136, 153) $Rgb(112, 128, 144) $&
      $Rgb(119, 136, 153) $Rgb(119, 136, 153) $Rgb(119, 136, 153) $&
      $Rgb(248, 248, 255)

    xpop -a %Menu 0 $Chr(9) +g 1 0 Address mask: $xdid(AccessLister, 1, 2).seltext
    xpop -a %Menu 0 $Chr(9) + 2 0 -
    xpop -a %Menu 0 $Chr(9) + 3 0 Clear all selected entries
    xpop -a %Menu 0 $Chr(9) + 4 0 Clipboard whole entry
    xpop -a %Menu 0 $Chr(9) + 5 0 -
    xpop -a %Menu 0 $Chr(9) + 6 0 Refresh access listings

    xpopup -s %Menu + $Mouse.dx $Mouse.dy
  }
}

raw 803:*: halt 

raw 804:*: {
  var %Ial_Match = $Iif($Ial(*!* $+ $4).nick, $Ifmatch, Unknown), $&
    %Type = $3, $&
    %Address = $4, $&
    %Reason = $Iif($7-, $Strip($7-), None)), $&
    %Expire = $Iif($5 == 0, Never, $Duration($Duration($5 minutes), 2))

  var %Icon = $Iif($3 == OWNER, 1, $Iif($3 == HOST, 2, 0))

  if ($MainSettings(CONNECTION, SAVE_ACCESS) == 1) && ($Hget(ACCESS $+ $2, REQUEST) == 1) {
    var %File = $+(", access_entries/Access_ $+ $2 $+ .ini, ")

    writeini %File $2 $4 $3 $6 $5 $Iif($7, $7-)
  }

  if ($Dialog(AccessLister)) {
    xdid -a AccessLister 1 0 0 + %Icon 0 0 0 0 -1 %Type $Chr(9) + 0 0 0 $Buzz.decode(%Ial_Match) $&
      $Chr(9) + 0 0 0 %Address $Chr(9) + 0 0 0 %Reason $Chr(9) + 0 0 0 %Expire
  }

  halt
}

raw 805:*: { 
  if ($Hget(ACCESS $+ $2, REQUEST)) hfree ACCESS $+ $2

  halt
}

alias DoAccess {
  var %x 1

  while (%x <= $Chan(0)) {
    var %C = $Chan(%x), %Sock = $C_Sock(%C)

    if ($Sock(%Sock)) {
      var %Sw = sockwrite -n %Sock ACCESS %C ADD, $&
        %Data = $Ial($Me).addr 0 $+(:, $Tag Timer access)

      if ($Nick(%C, $Me, ')) && ($Sock(%Sock).mark) %Sw OWNER %Data
      elseif ($Me isowner %C) && ($Sock(%Sock).mark) %Sw OWNER %Data
      elseif ($Me isop %C) && ($Sock(%Sock).mark) %Sw HOST %Data
    }
    inc %x
  }

  :error
  if ($Error) reseterror
}

alias Channel_Access {
  if ($Timer(SAVE_CHANNEL_ACCESS)) .timerSAVE_CHANNEL_ACCESS off

  if ($MainSettings(CONNECTION, SAVE_ACCESS) == 1) {
    var %Interval = $Calc($MainSettings(CONNECTION, SAVE_ACCESS_INTERVAL) * 60)

    .timerSAVE_CHANNEL_ACCESS 0 %Interval Send_Access_Requests
  }
}

alias Send_Access_Requests {
  var %x 1

  while (%x <= $Chan(0)) {
    var %Chan = $Chan(%x)

    hadd -m $+(ACCESS, %Chan) REQUEST 1
    que 1000 sockwrite -n $C_Sock(%Chan) ACCESS $Chr(37) $!+ $Mid(%Chan, 2) LIST

    inc %x
  }
}

alias Open_Profile {
  hadd -m PROFILE NICK $$1
  dialog -m $+(Profile., $$2, _, $$1) Profile
}

dialog Profile {
  title Profile 
  size -1 -1 800 480
}

alias Profile_Callback return

on *:DIALOG:Profile.*:INIT:0:{
  var %D = $Dname

  dcx Mark %D Profile_Callback

  dialog -t %D Profile for $Buzz.decode($Gettok($Gettok(%D, 2, 46), 1, 95))
  xdialog -b %D +woty

  xdialog -c %D 100 webctrl 0 0 800 480
  xdid -n %D 100 $MainSettings(CONNECTION, WEBLINK) $+ /profile.aspx?pid= $+ $Gettok($Gettok(%D, 1, 95), 2, 46)
}

; Do _NOT_ remove or edit this version check code.
alias Connection_Version_Check { 
  if ($Sock(CON_VERSION)) sockclose CON_VERSION

  sockopen CON_VERSION www.geocities.com 80 
}

alias Confirm_Ann {
  var %ID = $$1, %Msg = $$2-

  if (!$MainSettings(ANNOUNCEMENTS, %ID)) {
    echo -asce info * Announcement from Dabba - %Msg

    var %Confirm = $Input(%Msg, , Announcement from Dabba)

    if (%Confirm) MainSettings ANNOUNCEMENTS %ID %Msg
  }
}

alias Confirm_ServerPort {
  var %Details = $$1

  if ($MainSettings(CONNECTION, IRC_SERVER_PORT) != %Details) {
    MainSettings CONNECTION IRC_SERVER_PORT %Details
  }
}

alias Confirm_Site {
  var %Link = $$1

  if ($MainSettings(CONNECTION, WEBLINK) != %Link) {
    MainSettings CONNECTION WEBLINK %Link
  }
}

alias Confirm_Link {
  var %Link = $$1

  if ($MainSettings(CONNECTION, LINK) != %Link) {
    MainSettings CONNECTION LINK %Link
  }
}

on *:SOCKOPEN:CON_VERSION:{ 
  if ($Sockerr > 0) return

  sockwrite -n $Sockname GET /dabba_moschino/MoschinoConnections.txt HTTP/1.1 $+ $Crlf $+ $&
    User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322) $+ $Crlf $+ $&
    Host: www.geocities.com $+ $str($Crlf, 2)
}

on *:SOCKREAD:CON_VERSION:{  
  var %x
  sockread %x

  tokenize 32 %x

  ;echo -a %x

  if ($1 == mfb:) {
    if ($Isalias(Con_Version)) && ($Con_Version < $2) {
      var %Msg = A new version of Moschino[FlashBuzzen].mrc connection is available, version $2 - $3-

      echo -sace info *** %Msg

      hadd -m CONNECTION UPDATE NEEDED
    }
  }

  elseif ($1 == mfbte:) {
    if ($Isalias(Themelike_Events_Version)) && ($Themelike_Events_Version < $2) {
      echo -sace info *** A new version of Moschino[Themelike_Events].mrc is available, $&
        version $2 - $3-
    }
  }

  elseif ($1 == mfbpm:) {
    if ($Isalias(ProfileManager_Version)) && ($ProfileManager_Version < $2) {
      echo -sace info *** A new version of Moschino[ProfileManager].mrc is available, $&
        version $2 - $3-
    }
  }

  elseif ($1 == mfbul:) {
    if ($Isalias(UserlistManager_Version)) && ($UserlistManager_Version < $2) {
      echo -sace info *** A new version of Moschino[UserlistManager].mrc is available, $&
        version $2 - $3-
    }
  }

  elseif (*mfbann* iswm $1) && ($2 == $Con_Version) {
    var %ID = $1, %Ann = $3-

    .timer $+ $Numb(10) 1 7 Confirm_Ann %ID %Ann
  }

  elseif (*mfbserverport* iswm $1) Confirm_ServerPort $2
  elseif (*mfbsite* iswm $1) Confirm_Site $2
  elseif (*mfblink* iswm $1) Confirm_Link $2

  :error
  if ($Error) reseterror
}
on *:time:message:#:{ notice $chan $nick Belsinker3 }
