/*
	Rebar DLL v0.2
	by ClickHeRe
	panodude@videotron.ca

	This DLL lets the user play with the mIRC switchbar/toolbar

*/

#include "RebaR.h"

// ##################################################################################################


void Signal(char *data) {	
	wsprintf(mData,"//.signal -n REBAR %s",data);
	SendMessage(mIRC_hwnd, WM_USER + 200,0,0);
}

void mIRC_Eval(void) {
	SendMessage(mIRC_hwnd, WM_USER + 201,0,0);
}

/*
void Signal() {	
	wsprintf(mData,"//.signal -n REBAR %s",signal);
	SendMessage(mIRC_hwnd, WM_USER + 200,0,0);
}
*/
// command to find MDI Client Handle
BOOL CALLBACK EnummIRCProc(HWND hwnd,LPARAM lp)
{
	char name[900];
	GetClassName(hwnd,name,900);
	if (!lstrcmpi(name,"MDIClient")) {
		MDI_hwnd = hwnd;
	}
	return TRUE;
}

// Command to find toolbar and switchbar handles
void GetToolSwbHwnd() {
	if (IsWindow(mIRC_hwnd)) {
		swb_hwnd = GetDlgItem(mIRC_hwnd,32949);
		toolb_hwnd = GetDlgItem(mIRC_hwnd,Tool_ID);
	}
}

// mIRC Resize MDI Function
void mIRC_size() {

	//MDI_max(GetWindow(MDI_hwnd,GW_CHILD));

  RECT mIRC_rc, toolb_rc, swb_rc, dock_l_rc, dock_r_rc, dock_t_rc, dock_b_rc;
	int tool_h, swb_x = 0, swb_y = 0, swb_w = 0, swb_h = 0, rebar_w, rebar_h;
	int MDI_x = 0, MDI_y = 0, MDI_w, MDI_h;

	int dock_l_x = 0, dock_l_y = 0, dock_l_w, dock_l_h;
	int dock_r_x = 0, dock_r_y = 0, dock_r_w, dock_r_h;
	int dock_t_x = 0, dock_t_y = 0, dock_t_w, dock_t_h;
	int dock_b_x = 0, dock_b_y = 0, dock_b_w, dock_b_h;

	GetClientRect(mIRC_hwnd,&mIRC_rc);
	
	// mIRC first calculations
	MDI_w = mIRC_rc.right - mIRC_rc.left;
	MDI_h = mIRC_rc.bottom - mIRC_rc.top;
	
	// rebar first calculations
	rebar_w = 0;
	rebar_h = 0;

	// if docked left window exists
	if (IsWindow(dock_l)) {
		GetClientRect(dock_l,&dock_l_rc);
		dock_l_w = dock_l_rc.right - dock_l_rc.left;
		dock_l_h = MDI_h;
	}
	else {
		dock_l_w = 0;
		dock_l_h = 0;
	}
	
	// if docked right window exists
	if (IsWindow(dock_r)) {
		GetClientRect(dock_r,&dock_r_rc);
		dock_r_w = dock_r_rc.right - dock_r_rc.left;
		dock_r_h = MDI_h;
	}
	else {
		dock_r_w = 0;
		dock_r_h = 0;
	}

	// if docked top window exists
	if (IsWindow(dock_t)) {
		GetClientRect(dock_t,&dock_t_rc);
		dock_t_w = MDI_w;
		dock_t_h = dock_t_rc.bottom - dock_t_rc.top;
	}
	else {
		dock_t_w = 0;
		dock_t_h = 0;
	}

	// if docked bottom window exists
	if (IsWindow(dock_b)) {
		GetClientRect(dock_b,&dock_b_rc);
		dock_b_w = MDI_w;
		dock_b_h = dock_b_rc.bottom - dock_b_rc.top;
	}
	else {
		dock_b_w = 0;
		dock_b_h = 0;
	}
	
	// toolbar window claculations
  if (IsWindow(toolb_hwnd) && !toolb_hide) {
		GetWindowRect(toolb_hwnd,&toolb_rc);
		tool_h = toolb_rc.bottom - toolb_rc.top;
	}
	else {
		tool_h = 0;
	}

	GetWindowRect(swb_hwnd,&swb_rc);
	swb_w = swb_rc.right - swb_rc.left;
	swb_h = swb_rc.bottom - swb_rc.top;

  MDI_y += tool_h;

	if (!swb_hide) {

		switch (swb_pos) {

			//left
			case 1: {
				MDI_x += swb_w;
				if (MDIismax) { }
				MDI_h -= tool_h; 
				MDI_w -= swb_w;
				swb_x = 0;
				swb_y += tool_h;
				swb_h = MDI_h;

				if (IsWindow(rebar_hwnd)) {
					MDI_h -= rebar_h;
					MDI_y += rebar_h;
					swb_y += rebar_h;
					swb_h -= rebar_h;
				}

				MDI_w -= (dock_l_w + dock_r_w);
				MDI_h -= (dock_t_h + dock_b_h);
				MDI_x += dock_l_w;

				dock_t_y = MDI_y;
				MDI_y += dock_t_h;

				dock_l_x += swb_w;
				dock_l_y = dock_r_y = MDI_y;
				dock_l_h = dock_r_h = MDI_h;

				dock_r_x = MDI_x + MDI_w;

				dock_b_y = MDI_y + MDI_h;

				swb_y += dock_t_h;
				swb_h = MDI_h;
			}
				break;

			//top
			case 2: {
				MDI_h -= (swb_h + 1);
				if (MDIismax) { }
				MDI_h -= tool_h; 
				MDI_y += (swb_h + 1);
				swb_x = 0;
				swb_y += tool_h;
				swb_w = MDI_w;

				if (IsWindow(rebar_hwnd)) {
					MDI_h -= rebar_h;
					MDI_y += rebar_h;
					swb_y += rebar_h;
				}
				
				MDI_w -= (dock_l_w + dock_r_w);
				MDI_h -= (dock_t_h + dock_b_h);
				MDI_x += dock_l_w;

				dock_t_y = MDI_y;
				MDI_y += dock_t_h;

				dock_l_y = dock_r_y = MDI_y;
				dock_l_h = dock_r_h = MDI_h;

				dock_r_x = MDI_x + MDI_w;

				dock_b_y = MDI_y + MDI_h;
			}
				break;

			//right
			case 3: {
				if (MDIismax) {  }
				MDI_h -= tool_h;
				swb_x = MDI_w - swb_w;
				MDI_w -= swb_w;
				swb_y += tool_h;
				swb_h = MDI_h;

				if (IsWindow(rebar_hwnd)) {
					MDI_h -= rebar_h;
					MDI_y += rebar_h;
					swb_y += rebar_h;
					swb_h -= rebar_h;
				}

				MDI_w -= (dock_l_w + dock_r_w);
				MDI_h -= (dock_t_h + dock_b_h);
				MDI_x += dock_l_w;

				dock_t_y = MDI_y;
				MDI_y += dock_t_h;

				dock_l_y = dock_r_y = MDI_y;
				dock_l_h = dock_r_h = MDI_h;

				dock_r_x = MDI_x + MDI_w;

				dock_b_y = MDI_y + MDI_h;

				swb_y += dock_t_h;
				swb_h = MDI_h;

			}
				break;

			//bottom
			case 4: {
				MDI_h -= swb_h + tool_h;
				swb_x = 0;
				swb_y = MDI_h + tool_h;
				swb_w = MDI_w;

				if (IsWindow(rebar_hwnd)) {
					MDI_h -= rebar_h;
					MDI_y += rebar_h;
				}

				MDI_w -= (dock_l_w + dock_r_w);
				MDI_h -= (dock_t_h + dock_b_h);
				MDI_x += dock_l_w;

				dock_t_y = MDI_y;
				MDI_y += dock_t_h;

				dock_l_y = dock_r_y = MDI_y;
				dock_l_h = dock_r_h = MDI_h;
				
				dock_r_x = MDI_x + MDI_w;

				dock_b_y = MDI_y + MDI_h;
			}
				break;

			case 0: 
				break;
		}
	}
	else {

		MDI_h -= tool_h;
		if (IsWindow(rebar_hwnd)) { 
			MDI_h -= rebar_h; 
			MDI_y += rebar_h; 
		}

		MDI_w -= (dock_l_w + dock_r_w);
		MDI_h -= (dock_t_h + dock_b_h);
		MDI_x += dock_l_w;

		dock_t_y = MDI_y;
		MDI_y += dock_t_h;

		dock_l_y = dock_r_y = MDI_y;
		dock_l_h = dock_r_h = MDI_h;
				
		dock_r_x = MDI_x + MDI_w;

		dock_b_y = MDI_y + MDI_h;
	}
	
	if (IsWindowVisible(swb_hwnd)) {
		SetWindowPos(swb_hwnd,0,swb_x,swb_y,swb_w,swb_h,SWP_NOZORDER);
	}
	if (IsWindowVisible(toolb_hwnd)) {
		SetWindowPos(toolb_hwnd,0,0,0,mIRC_rc.right - mIRC_rc.left,tool_h,SWP_NOZORDER);
	}
	if (IsWindow(dock_l)) {
		SetWindowPos(dock_l,0,dock_l_x,dock_l_y,dock_l_w,dock_l_h,SWP_NOZORDER);
	}
	if (IsWindow(dock_r)) {
		SetWindowPos(dock_r,0,dock_r_x,dock_r_y,dock_r_w,dock_r_h,SWP_NOZORDER);
	}
	if (IsWindow(dock_t)) {
		SetWindowPos(dock_t,0,dock_t_x,dock_t_y,dock_t_w,dock_t_h,SWP_NOZORDER);
	}
	if (IsWindow(dock_b)) {
		SetWindowPos(dock_b,0,dock_b_x,dock_b_y,dock_b_w,dock_b_h,SWP_NOZORDER);
	}
	SetWindowPos(MDI_hwnd,0,MDI_x,MDI_y,MDI_w,MDI_h,SWP_NOZORDER);
}

// Returns The Switchbar position
int mIRC_swb_pos() {
  
  RECT swb_rc, mIRC_rc, toolb_rc;

	if (IsWindow(swb_hwnd)) { 
		GetWindowRect(swb_hwnd,&swb_rc);
		GetWindowRect(mIRC_hwnd,&mIRC_rc);

		int tool_h = 0;

		if (IsWindowVisible(toolb_hwnd)) { 
			GetWindowRect(toolb_hwnd,&toolb_rc);
			tool_h = toolb_rc.bottom - toolb_rc.top;
		}

		int xl = swb_rc.left - mIRC_rc.left;
		int xr = mIRC_rc.right - swb_rc.right;
		int yt = swb_rc.top - mIRC_rc.top - tool_h;
		int yb = mIRC_rc.bottom - swb_rc.bottom;

		if (mIRC_rc.left < 0 && mIRC_rc.right < 0 && mIRC_rc.top < 0 && mIRC_rc.bottom < 0) { return swb_pos; }

		if (xl < 10 && xr < 10) {
			// top
			if (yb > yt) { 
				return 2;
			}
			// bottom
			else {
				return 4;
			}
		}
		else {
			// left
			if (xr > xl) { 
				return 1;
			}
			// right
			else {
				return 3;
			}
		}
	}
	return 0;
}

void MDI_max(HWND hwnd) {

	RECT MDI_rc, SW_rc;

	GetClientRect(MDI_hwnd,&MDI_rc);
	GetClientRect(hwnd,&SW_rc);

	if ((MDI_rc.left == SW_rc.left) && (MDI_rc.right == SW_rc.right) && (MDI_rc.top == SW_rc.top) && (MDI_rc.bottom == SW_rc.bottom)) {
		MDIismax = TRUE;
	}	
	else {
		MDIismax = FALSE;
	}
}

// Removes window style to a window
void RemStyles(HWND hwnd,int parm,long RemStyles)
{
	LONG Styles = GetWindowLong(hwnd, parm);
	Styles &= ~RemStyles;
	SetWindowLong(hwnd, parm, Styles);
}

//	Adds window styles to a window
void AddStyles(HWND hwnd,int parm,long AddStyles)
{
	LONG Styles = GetWindowLong(hwnd, parm);
	Styles |= AddStyles;
	SetWindowLong(hwnd, parm, Styles);
}

// resets a docked window to original state
void ResetWindow(HWND hwnd, int oldpos) { 
	
	if (IsWindow(hwnd)) {

		switch (oldpos) { 

			case 1:
			{
				SetParent(hwnd,dockp_t);
				dock_t = NULL;
			}
			break;

			case 2:
			{
				SetParent(hwnd,dockp_l);
				dock_l = NULL;
			}
			break;

			case 3:
			{
				SetParent(hwnd,dockp_r);
				dock_r = NULL;
			}
			break;

			case 4:
			{
				SetParent(hwnd,dockp_b);
				dock_b = NULL;
			}
			break;
			
			default:
				break;
		}
		
		// apply new window styles to suite undocking purpose
		AddStyles(hwnd,GWL_STYLE,WS_CAPTION|DS_FIXEDSYS|DS_SETFONT|DS_MODALFRAME|WS_POPUP);	
		AddStyles(hwnd,GWL_EXSTYLE,WS_EX_DLGMODALFRAME|WS_EX_WINDOWEDGE|WS_EX_CONTROLPARENT);
		RemStyles(hwnd,GWL_STYLE,WS_CHILDWINDOW);

		// reset position and order of dialog window
		SetWindowPos(hwnd,NULL,0,0,0,0,SWP_FRAMECHANGED | SWP_NOMOVE | SWP_NOSIZE | SWP_NOOWNERZORDER | SWP_NOACTIVATE);
	}
}

// ##################################################################################################
// mIRC Procedure Callback

Proc(mIRCProc)
{
	switch(uMsg)
	{
		case WM_SIZE: 
		{
			mIRC_size();
			lstrcpy(signal,"Resize");
			Signal(signal);
			return 0;
		}
		break;

		case WM_TIMER: 
		{

			switch(wParam) {

				case REBAR_TIMER:
				{
					swb_pos = mIRC_swb_pos();
					mIRC_size();
					KillTimer(mIRC_hwnd,REBAR_TIMER);
				}
				break;
			}
		}
		break;

		case WM_CAPTURECHANGED: 
		{
			MDI_max(GetWindow(MDI_hwnd,GW_CHILD));
			SetTimer(mIRC_hwnd,REBAR_TIMER,1,NULL);
			lstrcpy(signal,"Resized");
			Signal(signal);
		}
		break;

		case WM_WINDOWPOSCHANGED:
		{
			MDI_max(GetWindow(MDI_hwnd,GW_CHILD));
			mIRC_size();
		}
		break;

		case WM_ACTIVATE:
		{
			MDI_max(GetWindow(MDI_hwnd,GW_CHILD));
			mIRC_size();
		}
		break;
		
		case WM_CLOSE: 
		{
			SetWindowLong(mIRC_hwnd,GWL_WNDPROC,(LONG) mIRC_OldProc);
			PostMessage(hwnd, uMsg,0,0);
			return 0;
		}
		break;
	
		default:
			break;
	}
	return CallWindowProc(mIRC_OldProc,hwnd,uMsg,wParam,lParam);
}

// ##################################################################################################
// Load DLL command
void WINAPI LoadDll(LOADINFO* load)
{
	hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096,"mIRC");     
  mData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);
  mIRC_hwnd = load->mHwnd;
	load->mKeep = TRUE;

	//Subclass mIRC
	mIRC_OldProc = (WNDPROC)SetWindowLong(mIRC_hwnd,GWL_WNDPROC,(LONG)mIRCProc);
	
	// Find MDIClient Area Handle
	EnumChildWindows(mIRC_hwnd,(WNDENUMPROC)EnummIRCProc,NULL);

  // Toolbar ID determination on mIRC's version
  lstrcpy(mData,"$version");
  mIRC_Eval();

  if (lstrcmp(mData,"6.1") == 0)
    Tool_ID = 0;
  else
    Tool_ID = 200;

	GetToolSwbHwnd();

	if (IsWindow(toolb_hwnd) && IsWindowVisible(toolb_hwnd)) {
		toolb_hide = FALSE;
	}
	else {
		toolb_hide = TRUE;
	}

	if (IsWindow(swb_hwnd) && IsWindowVisible(swb_hwnd)) {
		swb_hide = FALSE;
	}
	else {
		swb_hide = TRUE;
	}

	MDI_max(GetActiveWindow());

	swb_pos = mIRC_swb_pos();
}

// Unload DLL command
int WINAPI UnloadDll(int timeout)
{
	if (!timeout)
  { 

		SetWindowLong(mIRC_hwnd,GWL_WNDPROC,(LONG) mIRC_OldProc);

		// reset toolbar and switchbar to original state
		if (IsWindow(dock_l)) {
			ResetWindow(dock_l,2);
		}
		if (IsWindow(dock_t)) {
			ResetWindow(dock_t,1);
		}
		if (IsWindow(dock_b)) {
			ResetWindow(dock_b,4);
		}
		if (IsWindow(dock_r)) {
			ResetWindow(dock_r,3);
		}

		// reset mIRC size
		mIRC_size();

		UnmapViewOfFile(mData);
		CloseHandle(hFileMap);
		return 1;
	}
  else return 0;
}

// ##################################################################################################
// External DLL Commands
mIRC(Version) 
{
	ret("RebaR DLL v0.2 by ClickHeRe 2003 - http://scriptsdb.org");
}

// ##################################################################################################
// Docking Commands

mIRC(Dock) {

	//char signal[900];
	char chwnd[200], cpos[200];

	HWND hwnd, old_docked;
	int old_dock;

	lstrcpy(chwnd,strtok(data,">"));
	lstrcpy(cpos,strtok(NULL," "));

	hwnd = (HWND) atoi(chwnd);

	if (!IsWindow(hwnd)) {
		ret("S_ERROR Invalid Window Handle");
	}

	// apply new window styles to suite docking purpose
	RemStyles(hwnd,GWL_STYLE,WS_CAPTION|DS_FIXEDSYS|DS_SETFONT|DS_MODALFRAME|WS_POPUP);	
	RemStyles(hwnd,GWL_EXSTYLE,WS_EX_DLGMODALFRAME|WS_EX_WINDOWEDGE|WS_EX_CONTROLPARENT);
	AddStyles(hwnd,GWL_STYLE,WS_CHILDWINDOW);

	if (!lstrcmpi(cpos,"top")) {
		if (dock_t == hwnd) { ret("S_ERROR This Window is already Docked in top position"); }
		if (IsWindow(dock_t)) {
			old_docked = dock_t;
			old_dock = 1;
		}
		dock_t = hwnd;
		dockp_t = SetParent(hwnd,mIRC_hwnd);
	}
	else if (!lstrcmpi(cpos,"left")) {  
		if (dock_l == hwnd) { ret("S_ERROR This Window is already Docked in left position"); }
		if (IsWindow(dock_l)) {
			old_docked = dock_l;
			old_dock = 2;
		}
		dock_l = hwnd;
		dockp_l = SetParent(hwnd,mIRC_hwnd);
	}
	else if (!lstrcmpi(cpos,"right"))	{  
		if (dock_r == hwnd) { ret("S_ERROR This Window is already Docked in right position"); }
		if (IsWindow(dock_r)) {
			old_docked = dock_r;
			old_dock = 3;
		}
		dock_r = hwnd;
		dockp_r = SetParent(hwnd,mIRC_hwnd);
	}
	else if (!lstrcmpi(cpos,"bottom")) {  
		if (dock_b == hwnd) { ret("S_ERROR This Window is already Docked in botton position"); }
		if (IsWindow(dock_b)) {
			old_docked = dock_b;
			old_dock = 4;
		}
		dock_b = hwnd;
		dockp_b = SetParent(hwnd,mIRC_hwnd);
	}
	else { 
		ret("S_ERROR Invalid Docking position");
	}

	// reset old docked window to original state, parent, styles, etc..
	if (old_docked) {
		ResetWindow(old_docked, old_dock);
	}

	mIRC_size();
	//UpdateWindow(mIRC_hwnd);

	ret("S_OK");
}

mIRC(UnDock) {

  //char signal[900];
	char cpos[200];

	HWND old_docked;
	int old_dock;

	lstrcpy(cpos,strtok(data,""));

	if (!lstrcmpi(cpos,"top")) { 
		if (IsWindow(dock_t)) {
			old_docked = dock_t;
			dock_t = NULL;
			old_dock = 1;
		}
		else { 
			ret("S_ERROR No Window Docked At This Position");
		}
	}
	else if (!lstrcmpi(cpos,"left")) {  
		if (IsWindow(dock_l)) {
			old_docked = dock_l;
			dock_l = NULL;
			old_dock = 2;
		}
		else { 
			ret("S_ERROR No Window Docked At This Position");
		}
	}
	else if (!lstrcmpi(cpos,"right"))	{  
		if (IsWindow(dock_r)) {
			old_docked = dock_r;
			dock_r = NULL;
			old_dock = 3;
		}
		else { 
			ret("S_ERROR No Window Docked At This Position");
		}
	}
	else if (!lstrcmpi(cpos,"bottom")) {  
		if (IsWindow(dock_b)) {
			old_docked = dock_b;
			dock_b = NULL;
			old_dock = 4;
		}
		else { 
			ret("S_ERROR No Window Docked At This Position");
		}
	}
	else { 
		ret("S_ERROR Invalid UnDocking position");
	}

	if (old_docked) {
		ResetWindow(old_docked, old_dock);
	}

	mIRC_size();

	ret("S_OK");
}
// #####################################################################################
// mIRC hide/show Commands

// hides switchbar
mIRC(HideSwitchbar) {
  if (IsWindow(swb_hwnd) && !swb_hide) {
		ShowWindow(swb_hwnd,SW_HIDE);
		swb_hide = TRUE;
		mIRC_size();
		SetTimer(mIRC_hwnd,REBAR_TIMER,1,NULL);
		ret("S_OK Hide mIRC SwitchBar");
	}
	else {
		ret("S_ERROR Hide mIRC SwitchBar Failed");
	}
}

// shows switchbar
mIRC(ShowSwitchbar) {
	if (IsWindow(swb_hwnd) && swb_hide) {
		ShowWindow(swb_hwnd,SW_SHOW);
		swb_hide = FALSE;
		mIRC_size();
		SetTimer(mIRC_hwnd,REBAR_TIMER,1,NULL);
		//mIRC_size();
		ret("S_OK Show mIRC SwitchBar");
	}
	else {
		ret("S_ERROR Show mIRC SwitchBar Failed");
	}
}


// hides toolbar
mIRC(HideToolbar) {
  if (IsWindow(toolb_hwnd) && !toolb_hide) {
		ShowWindow(toolb_hwnd,SW_HIDE);
		toolb_hide = TRUE;
		SetTimer(mIRC_hwnd,REBAR_TIMER,1,NULL);
		ret("S_OK Hide mIRC ToolBar");
	}
	else {
		ret("S_ERROR Hide mIRC ToolBar Failed");
	}
}

// shows toolbar
mIRC(ShowToolbar) {
	if (IsWindow(toolb_hwnd)  && toolb_hide) {
		ShowWindow(toolb_hwnd,SW_SHOW);
		toolb_hide = FALSE;
		mIRC_size();
		SetTimer(mIRC_hwnd,REBAR_TIMER,1,NULL);
		ret("S_OK Show mIRC ToolBar");
	}
	else {
		ret("S_ERROR Show mIRC ToolBar Failed");
	}
}

// returns switchbar position
mIRC(SwitchbarPos) {

	switch(mIRC_swb_pos()) {

		case 1:
		{
			ret("left");
		}
		break;

		case 2:
		{
			ret("top");
		}
		break;

		case 3:
		{
			ret("right");
		}
		break;

		case 4:
		{
			ret("bottom");
		}
		break;

		default:
		{
			ret("none");
		}
		break;

	}
}

// returns if swb is visible or not
mIRC(IsSwitchbar) {

	if (IsWindow(swb_hwnd) && IsWindowVisible(swb_hwnd)) {
		ret("$true");
	}
	else {
		ret("$false");
	}
}


// returns if toolbar is visible or not
mIRC(IsToolbar) {

	if (IsWindow(toolb_hwnd) && IsWindowVisible(toolb_hwnd)) {
		ret("$true");
	}
	else {
		ret("$false");
	}
}
// returns if mIRC MDI is maxed
mIRC(MDIInfo) {

	MDI_max(GetWindow(MDI_hwnd,GW_CHILD));
	if (MDIismax) {
		ret("$true");
	}
	else {
		ret("$false");
	}
}

// returns Switchbar W H
mIRC(SwitchbarInfo) {
  RECT rc;
	GetWindowRect(swb_hwnd,&rc);

	wsprintf(data,"%d %d",rc.right - rc.left, rc.bottom - rc.top);
	return 3;
}

// returns Toolbar W H
mIRC(ToolbarInfo) {
  RECT rc;
	GetWindowRect(toolb_hwnd,&rc);

	wsprintf(data,"%d %d",rc.right - rc.left, rc.bottom - rc.top);
	return 3;
}